﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ChartTool
{
    public partial class FormScaling : Form
    {
        Chart2D ucmain;

        public FormScaling(Chart2D m)
        {
            InitializeComponent();
            ucmain = m;
        }

        private void DoubleGapbutton_Click(object sender, EventArgs e)
        {
            double temp = 0;

            ucmain.ConvertToDouble(XGaptextBox.Text, ref temp);
            XGaptextBox.Text = (temp / 2.0).ToString();
            ucmain.ConvertToDouble(XminGaptextBox.Text, ref temp);
            XminGaptextBox.Text = (temp / 2.0).ToString();
            tBCursorX.Text = XminGaptextBox.Text;
            ucmain.ConvertToDouble(YGaptextBox.Text, ref temp);
            YGaptextBox.Text = (temp / 2.0).ToString();
            ucmain.ConvertToDouble(YMinGaptextBox.Text, ref temp);
            YMinGaptextBox.Text = (temp / 2.0).ToString();
            tBCursorY.Text = YMinGaptextBox.Text;
        }

        private void Abbruchbutton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            Close();
        }

        private void Okbutton_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            Close();
        }

        private void XMaxtextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }

        private void XMintextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }

        private void XGaptextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }

        private void YMaxtextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }

        private void YMintextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }

        private void YGaptextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Enter in TextBox
            if (e.KeyChar == 13) //13 = Return
            {
                e.Handled = true; //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.OK;
                Close();
            }
            else if (e.KeyChar == 27) //27 = esc
            {
                e.Handled = true;  //Windows Beep-Sound deaktivieren (beim drücken)
                this.DialogResult = DialogResult.Cancel;
                Close();
            }
        }

        private void cBY2_CheckedChanged(object sender, EventArgs e)
        {
            gBY2Axis.Visible = cBY2.Checked;
            if (gBY2Axis.Visible)
             {
                if (Y2GaptextBox.Text=="0")
                {
                    Y2GaptextBox.Text = YGaptextBox.Text;
                    Y2MinGaptextBox.Text = YMinGaptextBox.Text;
                }
            }
        }

        private void butAutoScale_Click(object sender, EventArgs e)
        {
            ucmain.autoScaling();
        }

        private void FormScaling_Load(object sender, EventArgs e)
        {
            checkedListBox1.Items.Clear();
            if (ucmain.chart1.ChartAreas[0].AxisY2.Enabled == System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True)
                cBY2.Checked = true;
            for (int i = 0; i < ucmain.chart1.Series.Count;i++)
            {
                checkedListBox1.Items.Add(ucmain.chart1.Series[i].LegendText);
                if (ucmain.chart1.Series[i].YAxisType == System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary)
                    checkedListBox1.SetItemChecked(i,true);
                 
            }
        }

        private void FormScaling_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Set all checked Seris to Y2- Axis
            
            for (int i=0; i<ucmain.chart1.Series.Count;i++) // first set all to y1
                ucmain.chart1.Series[i].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Primary;
            
            for (int i = 0; i < checkedListBox1.CheckedIndices.Count; i++)
            {
                int index = checkedListBox1.CheckedIndices[i];  // only selectes to y2
                ucmain.chart1.Series[index].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary;

            }
            if (checkedListBox1.CheckedIndices.Count > 0)
            {
                ucmain.chart1.ChartAreas[0].AxisY2.Enabled = System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True;
                //ucmain.displayCoordY2 = true;  // ab 7.15 nicht mehr nötig
            }
            else
            {
                ucmain.chart1.ChartAreas[0].AxisY2.Enabled = System.Windows.Forms.DataVisualization.Charting.AxisEnabled.False;
                //ucmain.displayCoordY2 = false; // ab 7.15 nicht mehr nötig 
            }
        }

        private void rBPhase90_CheckedChanged(object sender, EventArgs e)
        {
            if (rBPhase90.Checked)
            {
                Y2MaxtextBox.Text = "90";
                Y2MintextBox.Text = "-270";
                Y2GaptextBox.Text = "20";
                Y2MinGaptextBox.Text = "5";
            }
        }

        private void rBPhase180_CheckedChanged(object sender, EventArgs e)
        {
            if (rBPhase180.Checked)
            {
                Y2MaxtextBox.Text = "180";
                Y2MintextBox.Text = "-180";
                Y2GaptextBox.Text = "20";
                Y2MinGaptextBox.Text = "5";
            }

        }

        //private void rBAutoscaleY2_Click(object sender, EventArgs e)
        //{
            
        //}

        private void butAutoScY2_Click(object sender, EventArgs e)
        {
            ucmain.autoscaleY2();
        }

        private void checkedListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            FormScaling_FormClosing(null, null);
        }

        private void butFixYtoY2_Click(object sender, EventArgs e)
        {
            ucmain.Fix_YwithY2();
        }
    }
}