﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

//Prinzip abgeleitete ArrayList aus Buch Visual C# 2008

namespace CurveList
{
    public class KoordList : CollectionBase //Abgeleitete Klasse von ArrayList, hier alles in double, da die ArrayList ursprünglich Objekte nutzt, vereinfacht Rechenoperationen
    {
        #region Indexer

        //Wert an Indexstelle zurückliefern
        public double this[int index]
        {
            get { return (double)this.InnerList[index]; } 
        }

        #endregion

        #region Methoden

        //Am Ende der Liste einen Wert hinzufügen
        public int Add (double value)
        {
            return this.InnerList.Add(value);
        }

        //Komplette Liste löschen
        public void ClearList()
        {
            this.InnerList.Clear();
        }

        //Fügt an der angegebenen Stelle einen neuen Wert ein, der Alte wird überschrieben
        public void Replace(int index, double value)
        {
            this.InnerList.RemoveAt(index); //Wert an Indexstelle löschen
            this.InnerList.Insert(index, value); //Neuen Wert an Indexstelle hinzufügen
        }

        //Löscht ab der angegebenen Position die Liste
        public void CutList(int index)
        {
            while (index <= this.InnerList.Count - 1) 
            {
                this.InnerList.RemoveAt(index);
            }
        }

        //Maximalen Wert suchen
        public double Max()
        {
            if (this.InnerList.Count > 0)
            {
                double max = 0;
                max = (double)this.InnerList[0];
                for (int i = 0; i < this.InnerList.Count - 1; i++)
                {
                    if (max < (double)this.InnerList[i + 1]) max = (double)this.InnerList[i + 1];
                }
                return max;
            }
            else return -1e11; //Falls keine Werte in der Liste vorhanden sind, wird ein kleiner Wert zurückgegeben
        }

        //Minimalen Wert suchen
        public double Min()
        {
            if (this.InnerList.Count > 0)
            {
                double min = 0;
                min = (double)this.InnerList[0];
                for (int i = 0; i < this.InnerList.Count - 1; i++)
                {
                    if (min > (double)this.InnerList[i + 1]) min = (double)this.InnerList[i + 1];
                }
                return min;
            }
            else return 1e11; //Falls keine Werte in der Liste vorhanden sind, wird ein großer Wert zurückgegeben
        }

        //Umwandlung der ArrayList in ein normales Array
        public object[] ToArray()
        {
            return this.InnerList.ToArray();
        }

        #endregion

        #region Konstruktor

        public KoordList() { }

        #endregion
    }
}
