﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.Drawing.Drawing2D;
using System.IO;

namespace Chart2D_ClassLibrary
{
    [
    Designer(typeof(Chart2D_ClassLibrary.ChartDesigner))
    ]

    public partial class Chart2D : UserControl
    {
        public Chart2D()
        {
            InitializeComponent();

           
            frmprint = new FormPrint(this);

            dataGridViewIni();

            if (ger)
                german();
            else
                english();
        }

        #region Variables

        //Zusätzliche Fenster
        FormTitle frmtitle;
        FormScaling frmscaling;
        
        FormPrint frmprint;

        Point MousePos;
        string ChartAreaName = "";
        PointF point1;
        PointF point2;

        double xVal, yVal;   // The actual position of the mouse based on the scale of the coordinate.

        int PenScale = 1;
        bool BlackColor = false;
        List<Color> colorstack = new List<Color>();

        
        private bool zoom = false;
        private bool cutClick;
        bool ger = false;

        int cutSelect = -1; //Welche Kurve wurde beim Abschneiden ausgewählt

        //Array für die Anzahl der Punkte pro Kurve
        int[] pointsCount = new int[10];

        private int number_of_points;
        private int column_number;

        

        #endregion


        #region Hinzugefügte Eigenschaften

        #region Buttons

        [Category("Buttonleiste")]
        [Description("X-Grid Button einblenden/ausblenden")]
        public bool XGridButton
        {
            get { return this.checkButtonXGrid.Visible; }
            set { this.checkButtonXGrid.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Y-Grid Button einblenden/ausblenden")]
        public bool YGridButton
        {
            get { return this.checkButtonYGrid.Visible; }
            set { this.checkButtonYGrid.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Manuelle Skalierung Button einblenden/ausblenden")]
        public bool ScallingButton
        {
            get { return this.buttonScaling.Visible; }
            set { this.buttonScaling.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Automatische Skalierung Button einblenden/ausblenden")]
        public bool AutoScaleButton
        {
            get { return this.buttonAutoScale.Visible; }
            set { this.buttonAutoScale.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Editor Button einblenden/ausblenden")]
        public bool EditorButton
        {
            get { return this.checkButtonEditor.Visible; }
            set { this.checkButtonEditor.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Legende Button einblenden/ausblenden")]
        public bool LegendButton
        {
            get { return this.checkButtonLegend.Visible; }
            set { this.checkButtonLegend.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Alle Kurven löschen Button einblenden/ausblenden")]
        public bool AllClearButton
        {
            get { return this.buttonAllClear.Visible; }
            set { this.buttonAllClear.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Letzte Kurve löschen Button einblenden/ausblenden")]
        public bool LastClearButton
        {
            get { return this.buttonLastClear.Visible; }
            set { this.buttonLastClear.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Schriftstärke Button einblenden/ausblenden")]
        public bool PenScaleButton
        {
            get { return this.checkButtonPenScale.Visible; }
            set { this.checkButtonPenScale.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Hintergrundfarbe Button einblenden/ausblenden")]
        public bool BackColorButton
        {
            get { return this.buttonBackColor.Visible; }
            set { this.buttonBackColor.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Schwarz/Weiß Button einblenden/ausblenden")]
        public bool ColorBlackButton
        {
            get { return this.checkButtonColorBlack.Visible; }
            set { this.checkButtonColorBlack.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Über-/Unterschrift Button einblenden/ausblenden")]
        public bool TitleButton
        {
            get { return this.buttonTitle.Visible; }
            set { this.buttonTitle.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Drucken Button einblenden/ausblenden")]
        public bool PrintButton
        {
            get { return this.buttonPrint.Visible; }
            set { this.buttonPrint.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Zoom Button einblenden/ausblenden")]
        public bool ZoomButton
        {
            get { return this.checkButtonZoom.Visible; }
            set { this.checkButtonZoom.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Info Button einblenden/ausblenden")]
        public bool InfoButton
        {
            get { return this.buttonInfo.Visible; }
            set { this.buttonInfo.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Speicher Button einblenden/ausblenden")]
        public bool SaveButton
        {
            get { return this.buttonSave.Visible; }
            set { this.buttonSave.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Laden Button einblenden/ausblenden")]
        public bool LoadButton
        {
            get { return this.buttonLoad.Visible; }
            set { this.buttonLoad.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("ButtonLeiste einblenden/ausblenden")]
        public bool ButtonPanel
        {
            get { return this.Bpanel.Visible; }
            set { this.Bpanel.Visible = value; }
        }

        #endregion

        #region Spracheinstellung

        [Category("Spracheinstellung")]
        [Description("Deutsch einschalten")]
        public bool Germanlanguage
        {
            get { return this.ger; }
            set
            {
                this.ger = value;
            }
        }

        #endregion

        #region Chart

        
        [
        Category("Chart"),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Content)
        ]
        /// <summary>
        /// This property is essential to allowing the designer to work and
        /// the DesignerSerializationVisibility Attribute (above) is essential
        /// in allowing serialization to take place at design time.
        /// </summary>
        public Chart MainChart
        {
            get
            {
                return this.mainChart;
            }
        }

        #endregion

        #endregion


        #region Event Handler

        private void Chart2D_Load(object sender, EventArgs e)
        {
            
            Menu_Strip_Content_Config();
            if (mainChart.ChartAreas.Count > 0)
            {
                ChartAreaName = mainChart.ChartAreas[0].Name;
                AutoScale();
            }
        }


        private void cutGraph_DropDownItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            if (!cutGraph.Checked)
            {
                for (int i = 0; i < cutGraph.DropDownItems.Count; i++)
                {
                    if (e.ClickedItem == cutGraph.DropDownItems[i])
                    {
                        cutClick = true;
                        cutSelect = i;

                        if (showKoord.Checked == true)
                        {
                            showKoord.Checked = false;
                            showKoord.CheckState = CheckState.Unchecked;
                            label1.Visible = false;
                        }

                    }
                }
                cutGraph.CheckState = CheckState.Checked;
            }
            else
            {
                cutGraph.CheckState = CheckState.Unchecked;
                cutClick = false;
                label1.Visible = false;
            }
            
        }



        private void mainChart_MouseClick(object sender, MouseEventArgs e)
        {
            if ((cutClick) && (e.Button == System.Windows.Forms.MouseButtons.Left))
                CutTheGraph();
        }


        private void showKoord_Click(object sender, EventArgs e)
        {
            if (showKoord.Checked)
            {
                showKoord.CheckState = CheckState.Unchecked;
                label1.Visible = false;
            }
            else
            {
                showKoord.CheckState = CheckState.Checked;
                cutClick = false;
            }
        }


        private void mainChart_MouseMove(object sender, MouseEventArgs e)
        {
            MousePos = new Point(e.X, e.Y);
            mainChart.Invalidate();
    
            if ((showKoord.Checked) || (cutClick))
                ShowCoorValues(e);
        }


        #endregion


        #region DatenEditor

        private void dataGridViewIni()
        {
            dataGridView2.ColumnCount = mainChart.Series.Count * 2;    // The default max value is 20.

            //Grundeinsellungen des DataGridView
            dataGridView2.SelectionMode = DataGridViewSelectionMode.CellSelect; //Nur Zellen und keine Spaltenauswahl und Zeilenauswahl
            dataGridView2.MultiSelect = false; //Nur eine Zelle zur Zeit auswählbar
            dataGridView2.DefaultCellStyle.SelectionBackColor = Color.LightSkyBlue; //Hintergrundfarbe bei Auswahl
            dataGridView2.AllowUserToOrderColumns = false; //Sortierung der Spalten deaktiviert
            dataGridView2.AllowUserToResizeRows = false; //Größenänderung der Zeilen deaktiviert

            //X-Achse: Schreibgeschützt und Farbe grau
            for (int i = 0; i <= mainChart.Series.Count - 2; i += 2)
            {
                dataGridView2.Columns[i].ReadOnly = true;
                dataGridView2.Columns[i].DefaultCellStyle.BackColor = Color.LightGray;
            }

            //Automatische Sortierung deaktivieren und Spalten beim Initialisieren nicht sichtbar
            for (int i = 0; i <= mainChart.Series.Count - 1; i++)
            {
                dataGridView2.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                dataGridView2.Columns[i].Visible = false;
            }
        }

        /// <summary>
        /// Übergabe von Daten an das DataGridView
        /// </summary>
        private void setEData()
        {
            //Spaltenüberschrift

            column_number = mainChart.Series.Count * 2;
            int n = 0;
            dataGridView2.Rows.Clear();
            dataGridView2.Columns.Clear();

            number_of_points = 0;

            //Search for the series with the most number of points.
            foreach (Series s in mainChart.Series)
            {
                if (s.Points.Count > number_of_points)
                    number_of_points = s.Points.Count;
            }

            dataGridView2.ColumnCount = column_number;

            for (int i = 0; i < number_of_points; i++)
            {
                dataGridView2.Rows.Add();
                dataGridView2.Rows[i].HeaderCell.Value = (i + 1).ToString();
            }

            for (int i = 0; i < column_number; i++)
            {
                if (i > 0 && (i % 2 == 0))
                    n++;

                if (i % 2 != 0)
                {
                    dataGridView2.Columns[i].HeaderText = mainChart.Series[n].Name + ": Y";
                    //Add values to column. The number_of_points variable is equivalent to the number of rows in the datagridview. 
                    for (int j = 0; j < mainChart.Series[n].Points.Count; j++)
                    {
                        dataGridView2[i, j].Value = mainChart.Series[n].Points[j].YValues[0].ToString("g6");
                    }
                }
                else if (i % 2 == 0)
                {
                    dataGridView2.Columns[i].HeaderText = mainChart.Series[n].Name + ": X";
                    //Add values to column. The number_of_points variable is equivalent to the number of rows in the datagridview. 
                    for (int j = 0; j < mainChart.Series[n].Points.Count; j++)
                    {
                        dataGridView2[i, j].Value = mainChart.Series[n].Points[j].XValue.ToString("g6");
                    }
                }
            }
        }


        private void GetData()
        {
            int n = 0;

            for (int i = 0; i < column_number; i++)
            {
                if (i > 0 && (i % 2 == 0))
                    n++;

                if (i % 2 != 0)
                {
                    //Add values to column. The number_of_points variable is equivalent to the number of rows in the datagridview. 
                    for (int j = 0; j < mainChart.Series[n].Points.Count; j++)
                    {
                        mainChart.Series[n].Points[j].YValues[0] = Convert.ToDouble(dataGridView2[i, j].Value);
                    }
                }
                else if (i % 2 == 0)
                {
                    
                    //Add values to column. The number_of_points variable is equivalent to the number of rows in the datagridview. 
                    for (int j = 0; j < mainChart.Series[n].Points.Count; j++)
                    {
                        mainChart.Series[n].Points[j].YValues[0] = Convert.ToDouble(dataGridView2[i, j].Value);
                    }
                }
            }
        }

        private void dataGridView2_RowValidated(object sender, DataGridViewCellEventArgs e)
        {
            int serie_index;

            if ((e.RowIndex < number_of_points) && (e.ColumnIndex < mainChart.Series.Count * 2) && (e.ColumnIndex % 2 != 0))
            {
                serie_index = e.ColumnIndex % 2 == 0 ? e.ColumnIndex / 2 : (e.ColumnIndex - 1) / 2;
                mainChart.Series[serie_index].Points[e.RowIndex].YValues[0] = Convert.ToDouble(dataGridView2[e.ColumnIndex, e.RowIndex].Value);
            }
        }

        #endregion


        #region Laden und Speichern einer Datei

        private void saveChart(string filename)
        {
            mainChart.Serializer.Content = SerializationContents.Default;
            mainChart.Serializer.Save(filename);
        }


        private void loadChart(string filename)
        {
            mainChart.Serializer.Load(filename);
        }

        #endregion


        #region Sprache

        #region Englisch

        private void english()
        {
            buttonScaling.ToolTipText = "manual scaling";
            checkButtonXGrid.ToolTipText =  "X-grid";
            checkButtonYGrid.ToolTipText = "Y-grid";
            buttonAutoScale.ToolTipText = "autoscale curve";
            checkButtonEditor.ToolTipText = "toggle curve/table";
            checkButtonLegend.ToolTipText = "legend";
            buttonAllClear.ToolTipText = "clear all curves";
            buttonLastClear.ToolTipText = "clear last curve";
            checkButtonPenScale.ToolTipText =  "thick lines";
            buttonBackColor.ToolTipText = "change background color";
            checkButtonColorBlack.ToolTipText = "toggle curve color";
            buttonTitle.ToolTipText = "top/bottom title";
            buttonPrint.ToolTipText = "print";
            checkButtonZoom.ToolTipText =  "zoom";
            buttonSave.ToolTipText =  "save file";
            buttonLoad.ToolTipText =  "load file";
            buttonInfo.ToolTipText =  "about Chart2D";

            showKoord.Text = "show coordinates";
            cutGraph.Text = "cut curve";
            
        }

        #endregion

        #region Deutsch

        private void german()
        {           
            buttonScaling.ToolTipText = "Manuelle Skalierung";
            checkButtonXGrid.ToolTipText =  "X-Grid";
            checkButtonYGrid.ToolTipText =  "Y-Grid";
            buttonAutoScale.ToolTipText =  "Automatische Skalierung";
            checkButtonEditor.ToolTipText =  "Dateneditor";
            checkButtonLegend.ToolTipText =  "Legende ein-/ausblenden";
            buttonAllClear.ToolTipText = "Alle Kurven löschen";
            buttonLastClear.ToolTipText = "Letzte Kurve löschen";
            checkButtonPenScale.ToolTipText = "Doppelte Kurvenstärke";
            buttonBackColor.ToolTipText = "Hintergrundfarbe ändern";
            checkButtonColorBlack.ToolTipText = "Schwarz/Farbe";
            buttonTitle.ToolTipText = "Über-/Unterschrift";
            buttonPrint.ToolTipText = "Drucken";
            checkButtonZoom.ToolTipText = "Zoom";
            buttonSave.ToolTipText = "Datei speichern";
            buttonLoad.ToolTipText = "Datei laden";
            buttonInfo.ToolTipText = "Über Chart2D";

            showKoord.Text = "Koordinaten anzeigen";
            cutGraph.Text = "Kurve abschneiden";

          
        }

        #endregion


        #endregion


        #region Automatische Skalierung

        public void AutoScale()
        {
            double maxX, minX, maxY, minY, maxabswert;
            int zehnerpot, add;
            List<Series>[] list_serie = null;

            if (mainChart.ChartAreas.Count > 0)
            {
                list_serie = new List<Series>[mainChart.ChartAreas.Count];

                for (int i = 0; i < list_serie.Length; i++)
                {
                    list_serie[i] = new List<Series>();
                }
            }

            for ( int i = 0 ; i < mainChart.ChartAreas.Count; i++)
            {
                foreach ( Series s in mainChart.Series)
                {
                    if (s.ChartArea == mainChart.ChartAreas[i].Name)
                        list_serie[i].Add(s);
                }

                if (list_serie[i].Count > 0)
                {
                    maxX = list_serie[i][0].Points.FindMaxByValue("X").XValue;
                    minX = list_serie[i][0].Points.FindMinByValue("X").XValue;
                    maxY = list_serie[i][0].Points.FindMaxByValue("Y").YValues[0];
                    minY = list_serie[i][0].Points.FindMinByValue("Y").YValues[0];

                    foreach (Series serie in list_serie[i])
                    {
                        if (maxX < serie.Points.FindMaxByValue().XValue)
                            maxX = serie.Points.FindMaxByValue().XValue;
                        if (minX > serie.Points.FindMinByValue().XValue)
                            minX = serie.Points.FindMinByValue().XValue;
                        if (maxY < serie.Points.FindMaxByValue().YValues[0])
                            maxY = serie.Points.FindMaxByValue().YValues[0];
                        if (minY > serie.Points.FindMinByValue().YValues[0])
                            minY = serie.Points.FindMinByValue().YValues[0];
                    }

                    if (Math.Abs(maxY) > Math.Abs(minY))
                        maxabswert = Math.Abs(maxY);
                    else
                        maxabswert = Math.Abs(minY);

                    if (maxabswert < 2) 
                        add = -1; 
                    else 
                        add = 0;

                    //Prof. Dr. Bayerlein
                    //Entnommen aus Windf
                    /* ymax and ymin rounded between 2...19.99 to next 1
                                                    0.2 ... 1.999 to next 0.1
                                                    20 .. 199.9 to next 10
                                              and so on */
                    zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                    mainChart.ChartAreas[i].AxisY.Interval = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                    if (maxY > 0) add = 1; else add = 0;
                    mainChart.ChartAreas[i].AxisY.Maximum = mainChart.ChartAreas[i].AxisY.Interval * (int)(maxY / mainChart.ChartAreas[i].AxisY.Interval + add);
                    if (minY >= 0) add = 0; else add = -1;
                    mainChart.ChartAreas[i].AxisY.Minimum = mainChart.ChartAreas[i].AxisY.Interval * (int)(minY / mainChart.ChartAreas[i].AxisY.Interval + add);

                    /* xmax and xmin rounded between 2...19.99 to next 1
                                                0.2 ... 1.999 to next 0.1
                                                20 .. 199.9 to next 10
                                          and so on */
                    if (Math.Abs(maxX) > Math.Abs(minX)) maxabswert = Math.Abs(maxX);
                    else maxabswert = Math.Abs(minX);
                    if (maxabswert <= 2) add = -1; else add = 0;
                    zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                    mainChart.ChartAreas[i].AxisX.Interval = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                    if (maxX > 0) add = 1; else add = 0;
                    mainChart.ChartAreas[i].AxisX.Maximum = mainChart.ChartAreas[i].AxisX.Interval * (int)(maxX / mainChart.ChartAreas[i].AxisX.Interval + add);
                    if (minX >= 0) add = 0; else add = -1;
                    mainChart.ChartAreas[i].AxisX.Minimum = mainChart.ChartAreas[i].AxisX.Interval * (int)(minX / mainChart.ChartAreas[i].AxisX.Interval + add);


                }
            }
        }



        #endregion


        #region Button Click


        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                saveChart(saveFileDialog1.FileName);
            }
        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
                loadChart(openFileDialog1.FileName);
        }

        private void buttonPrint_Click(object sender, EventArgs e)
        {
            try
            {
                mainChart.Printing.Print(true);
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Chart Control for .NET Framework", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            frmprint = new FormPrint(this);
            frmprint.ShowDialog();
        }

        private void buttonTitle_Click(object sender, EventArgs e)
        {
            mainChart.Titles.Clear();
            mainChart.Titles.Add("Top Titel");
            mainChart.Titles.Add("Bottom Titel");
            mainChart.Titles[0].Visible = false;
            mainChart.Titles[1].Visible = false;
            frmtitle = new FormTitle(this);

            if (frmtitle.ShowDialog() == DialogResult.OK)
            {

                mainChart.Titles[0].Docking = Docking.Top;
                mainChart.Titles[1].Docking = Docking.Bottom;

                mainChart.Titles[0].Visible = true;
                mainChart.Titles[1].Visible = true;

                mainChart.Titles[0].Text = frmtitle.TopTitel;
                mainChart.Titles[1].Text = frmtitle.BottomTitel;
            }
            
        }

        private void checkButtonLegend_Click(object sender, EventArgs e)
        {
            if (mainChart.Legends.Count > 0)
            {
                if (mainChart.Legends[0].Enabled)
                {
                    mainChart.Legends[0].Enabled = false;
                }
                else
                {
                    mainChart.Legends[0].Enabled = true;
                } 
            }
        }

        private void checkButtonXGrid_Click(object sender, EventArgs e)
        {
            foreach (ChartArea chartarea in mainChart.ChartAreas)
            {
                if (chartarea.AxisX.MajorGrid.Enabled)
                    chartarea.AxisX.MajorGrid.Enabled = false;
                else
                    chartarea.AxisX.MajorGrid.Enabled = true;

                //if (chartarea.AxisX.MinorGrid.Enabled)
                //    chartarea.AxisX.MinorGrid.Enabled = false;
                //else
                //    chartarea.AxisX.MinorGrid.Enabled = true;
            }
        }

        private void checkButtonYGrid_Click(object sender, EventArgs e)
        {
            foreach (ChartArea chartarea in mainChart.ChartAreas)
            {
                if (chartarea.AxisY.MajorGrid.Enabled)
                    chartarea.AxisY.MajorGrid.Enabled = false;
                else
                    chartarea.AxisY.MajorGrid.Enabled = true;

                //if (chartarea.AxisY.MinorGrid.Enabled)
                //    chartarea.AxisY.MinorGrid.Enabled = false;
                //else
                //    chartarea.AxisY.MinorGrid.Enabled = true;
            }
        }

        private void checkButtonEditor_Click(object sender, EventArgs e)
        {
            if (dataGridView2.Visible)
            {
                dataGridView2.Visible = false;
                GetData();
                //AutoScale();
                mainChart.BringToFront();
                label1.BringToFront();
                dataGridView2.SendToBack();
                Bpanel.SendToBack();
                mainChart.Invalidate();
            }
            else
            {
                dataGridView2.Visible = true;
                mainChart.SendToBack();
                dataGridView2.BringToFront();
                Bpanel.SendToBack();
                setEData();
            }

            //Bpanel.BackColor = Color.Green;
        }

        private void checkButtonZoom_Click(object sender, EventArgs e)
        {

            if (!zoom)
            {
                zoom = true;
                foreach (ChartArea chartArea in mainChart.ChartAreas)
                {
                    chartArea.AxisX.ScaleView.Zoomable = true;
                    chartArea.AxisX.ScrollBar.IsPositionedInside = true;
                    chartArea.AxisX.ScrollBar.Enabled = true;
                    chartArea.AxisY.ScaleView.Zoomable = true;
                    chartArea.AxisY.ScrollBar.IsPositionedInside = true;
                    chartArea.AxisY.ScrollBar.Enabled = true;

                    //chartArea.CursorX.IsUserEnabled = true;
                    chartArea.CursorX.IsUserSelectionEnabled = true;
                    chartArea.CursorX.SelectionColor = Color.LightSlateGray;
                    //chartArea.CursorY.IsUserEnabled = true;
                    chartArea.CursorY.IsUserSelectionEnabled = true;
                    chartArea.CursorY.SelectionColor = Color.LightSlateGray;
                }
            }
            else
            {
                zoom = false;
                foreach (ChartArea chartArea in mainChart.ChartAreas)
                {
                    chartArea.AxisX.ScaleView.Zoomable = false;
                    chartArea.AxisX.ScrollBar.Enabled = false;
                    chartArea.AxisY.ScaleView.Zoomable = false;
                    chartArea.AxisY.ScrollBar.Enabled = false;
                    chartArea.CursorX.IsUserSelectionEnabled = false;
                    chartArea.CursorY.IsUserSelectionEnabled = false;
                    chartArea.AxisX.ScaleView.ZoomReset();
                    chartArea.AxisY.ScaleView.ZoomReset();
                }
            }
            //Bpanel.BackColor = Color.HotPink;
        }

        private void buttonScaling_Click(object sender, EventArgs e)
        {
            frmscaling = new FormScaling(this);
            if (frmscaling.ShowDialog() == DialogResult.OK)
            {
                mainChart.ChartAreas[frmscaling.nr].AxisX.Minimum = frmscaling.xMin;
                mainChart.ChartAreas[frmscaling.nr].AxisX.Maximum = frmscaling.xMax;
                mainChart.ChartAreas[frmscaling.nr].AxisY.Minimum = frmscaling.yMin;
                mainChart.ChartAreas[frmscaling.nr].AxisY.Maximum = frmscaling.xMax;

                mainChart.ChartAreas[frmscaling.nr].AxisX.Interval = frmscaling.xGap;
                mainChart.ChartAreas[frmscaling.nr].AxisY.Interval = frmscaling.yGap;

                mainChart.Invalidate();
                mainChart.ChartAreas.Invalidate();
            }
        }

        private void buttonAutoScale_Click(object sender, EventArgs e)
        {
            AutoScale();
        }

        private void buttonBackColor_Click(object sender, EventArgs e)
        {
            if (mainChart.ChartAreas.Count > 0)
            {
                colorDialog1.FullOpen = true;
                colorDialog1.Color = mainChart.ChartAreas[0].BackColor;

                if (colorDialog1.ShowDialog() == DialogResult.OK)
                {
                    mainChart.ChartAreas[0].BackColor = colorDialog1.Color;
                    mainChart.BackColor = colorDialog1.Color;
                }
            }
        }

        private void checkButtonColorBlack_Click(object sender, EventArgs e)
        {
            if (mainChart.Series.Count > 0)
            {
                
                if (!BlackColor)
                {
                    colorstack.Clear();
                    
                    for (int i = 0; i < mainChart.Series.Count; i++)
                    {
                        colorstack.Add(mainChart.Series[i].Color);
                        mainChart.Series[i].Color = Color.Black;
                    }
                        
                    BlackColor = true;
                }
                else
                {
                    for (int i = 0; i < mainChart.Series.Count; i++)
                        mainChart.Series[i].Color = colorstack[i];
                    BlackColor = false;
                }
                mainChart.Invalidate();
            }
        }

        private void checkButtonPenScale_Click(object sender, EventArgs e)
        {
            if (mainChart.Series.Count > 0)
            {
                if (PenScale == 1)
                {
                    PenScale = 3;
                    
                }
                else 
                {
                    PenScale = 1;
                }
                foreach (Series s in mainChart.Series)
                    s.BorderWidth = PenScale;
            }
        }

        private void buttonLastClear_Click(object sender, EventArgs e)
        {
            if (mainChart.Series.Count > 0)
                mainChart.Series.RemoveAt(mainChart.Series.Count - 1);
            mainChart.Invalidate();
        }

        private void buttonAllClear_Click(object sender, EventArgs e)
        {
            if (mainChart.Series.Count > 0)
                mainChart.Series.Clear();
            mainChart.Invalidate();
        }

        private void buttonInfo_Click(object sender, EventArgs e)
        {
            AboutBox1 info = new AboutBox1(); //Neues Objekt erstellen
            info.ShowDialog();  //Infofenster anzeigen
        }


        #endregion


        #region Chart Configuration

        // The curve which appears on the chart will also appear on the cut curve menu.
        private void Menu_Strip_Content_Config()
        {
            for (int i = 0; i < mainChart.Series.Count; i++)
            {
                ToolStripMenuItem curve = new ToolStripMenuItem(mainChart.Series[i].Name);
                curve.BackColor = mainChart.Series[i].Color;
                cutGraph.DropDownItems.Add(curve);
                cutGraph.DropDownItems[i].ForeColor = mainChart.Series[i].Color;
                cutGraph.DropDownItems[i].BackColor = mainChart.Series[i].Color;
            }
        }


        private void Chart2D_Resize(object sender, EventArgs e)
        {
            mainChart.Dock = DockStyle.Fill;
            Bpanel.Dock = DockStyle.Top;
            dataGridView2.Dock = DockStyle.Fill;
        }



        #endregion
        

        #region Zeichnen von Mauskreuz, Abschneidelinie und Zoomrechteck


        private void ShowCoorValues(MouseEventArgs e)
        {
            HitTestResult results = mainChart.HitTest(e.X, e.Y, ChartElementType.PlottingArea);       
            if (results.ChartElementType == ChartElementType.PlottingArea)
            {
                ChartAreaName = results.ChartArea.Name;
                
                label1.Visible = true;
                label1.Left = MousePos.X - 50;
                label1.Top = MousePos.Y;
                
                xVal = results.ChartArea.AxisX.PixelPositionToValue(e.X);
                yVal = results.ChartArea.AxisY.PixelPositionToValue(e.Y);

                label1.Text = "X = " + String.Format("{0:g3}", xVal) + " Y = " + String.Format("{0:g3}", yVal);
                
            }
        }

        //Draw The Cross Line
        private void mainChart_PostPaint(object sender, ChartPaintEventArgs e)
        {
            Pen pen = new Pen(Color.RoyalBlue);
            point1 = PointF.Empty;
            point2 = PointF.Empty;


            float pixelXMax = (float)e.ChartGraphics.GetPositionFromAxis(ChartAreaName, AxisName.X, mainChart.ChartAreas[ChartAreaName].AxisX.Maximum);
            float pixelXMin = (float)e.ChartGraphics.GetPositionFromAxis(ChartAreaName, AxisName.X, mainChart.ChartAreas[ChartAreaName].AxisX.Minimum);
            float pixelYMax = (float)e.ChartGraphics.GetPositionFromAxis(ChartAreaName, AxisName.Y, mainChart.ChartAreas[ChartAreaName].AxisY.Maximum);
            float pixelYMin = (float)e.ChartGraphics.GetPositionFromAxis(ChartAreaName, AxisName.Y, mainChart.ChartAreas[ChartAreaName].AxisY.Minimum);


            // Set Maximum and minimum points
            point1.X = pixelXMin;
            point1.Y = pixelYMin;
            point2.X = pixelXMax;
            point2.Y = pixelYMax;

            // Convert relative coordinates to absolute coordinates.
            point1 = e.ChartGraphics.GetAbsolutePoint(point1);
            point2 = e.ChartGraphics.GetAbsolutePoint(point2);

            if (showKoord.Checked)
            {   
                e.ChartGraphics.Graphics.DrawLine(pen, point1.X, MousePos.Y, point2.X, MousePos.Y);
                e.ChartGraphics.Graphics.DrawLine(pen, MousePos.X, point1.Y, MousePos.X, point2.Y);
            }
            else if (cutClick)
                e.ChartGraphics.Graphics.DrawLine(pen, MousePos.X, point1.Y, MousePos.X, point2.Y);
        }


        private void CutTheGraph()
        {
            Series curve = mainChart.Series[cutSelect];
            int i = 0;

            if (MessageBox.Show("Cut curve at this position ?","Confirm",MessageBoxButtons.OKCancel,MessageBoxIcon.Question) == DialogResult.OK)
            {
                while (i < curve.Points.Count)
                {
                    if (curve.Points[i].XValue > xVal)
                    {
                        curve.Points.RemoveAt(i);
                        i--;
                    }
                    i++;
                }
            }
           
            mainChart.Invalidate();
        }

        #endregion

        



        


        

        

        

        


       

       
    }
}
