﻿// Aus der Seckler -DA wird hier das gesamte Zeichnen mit der neuen 
// DotNet 4 - Chart ersetzt. Die Schnittstelle sowie die ToolButtons bleiben gleich.
// copyright Prof. Dr. Bayerlein


#region usings

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO; //Stream (Speichern/Laden)
using System.Drawing.Drawing2D; //GDI+
//using System.Drawing.Printing; //Drucken
using System.Windows.Forms.DataVisualization.Charting; //Eigene ArrayList
using System.Diagnostics;

#endregion

namespace ChartTool
{
    //Delegate für eigenes Event
    public delegate void CoordClickEventHandler( object sender, CoordClickEventArgs e );
       //Standard-Event beim Doppelklick in Visual Studio
       // [DefaultEvent("CoordClick")]

    public delegate void CounterChangedEventHandler(object sender, CounterChangedEventArgs e);
    //[DefaultEvent("OnCounterChanged")]

   
    public partial class Chart2D : UserControl
    {

       #region Variablen und Objekte

        //Zusätzliche Fenster
        FormName frmname;
        FormTitle frmtitle;
        FormScaling frmscaling;
        FormCutDialog frmcutdialog;
        FormSColFX frmColChange;
        

        //Mauskoordinaten
        Point MousePos;

        string allCurvesDeleted = "all Curves will be deleted, Sure?";

        //Strings für Zusatzfenster "Namen ändern"
        string ChangeName;
        string ChangeName2;

        //Array für die Kurvennamen (Public)
        public string[] CurveNames = new string[10]; 

        //Abfrage Variablen
        int xGrid = 0;
        int yGrid = 0;
        bool cutClick = false;
        bool black = false;
        bool zoom = false;
        bool ger = false;
        //public bool displayCoordY2 = false;

        float PenScale = 1; //Zeichenstärke
        int cutSelect = -1; //Welche Kurve wurde beim Abschneiden ausgewählt
        int rowCount = 0;  //Zähler für die Zeilenanzahl im DataGridView
 
        //Array für die Anzahl der Punkte pro Kurve
        int[] pointsCount = new int[10];
        bool[] IsY2local = new bool[10];
 
      double xVal, yVal,y2Val;   // The actual position of the mouse based on the scale of the coordinate.
      bool xlogdesired = false;

        // ScopeMode

        public bool[] scopeModeSwitch = new bool[5];
        Stopwatch time;
        long start_time, actual_time;
        public double scopeModeXTime;

        #endregion

        #region Convert egal ob Punkt oder Komma
        // Aus Bayerlein WindfC#
        public char comF, comR;   // to correct Comma- / point problem comF : wrong separator
        // comR  : correct separator
        string wrongDataFormat = "wrong Data Format";

        public void ConvertToDouble(string text, ref double nb)
        {
            // Secure Conversion independant of Komma- Version of PC
            // comF contains String with wrong camma, comR contains string with correct comma
            // if number format is wrong, result is old number
            // Call :  ConvertToDouble(text,ref number);
            // removes all thousand- Seperators
            // examples: (if decimal sep =".")
            // 1000,000,000.23 --> 1000000000.23
            // 1000.000.000,23 --> 1000000000.23
            // 0.23 --> 0.23
            // 0,23 --> 0.23
            // 1000,023 --> 1000.023
            // 1000.023 --> 1000.023

            // examples: (if decimal sep =",")
            // 1000,000,000.23 --> 1000000000,23
            // 1000.000.000,23 --> 1000000000,23
            // 0.23 --> 0,23
            // 0,23 --> 0,23
            // 1000,023 --> 1000,023
            // 1000.023 --> 1000,023

            string TestText = (0.1).ToString("f1");

            if (TestText.Substring(1, 1) == ".")  // Check which is the actual Decimal separator
            { comF = ','; comR = '.'; }
            else
            { comF = '.'; comR = ','; }

            double number = 0;
            char[] seps = new char[2];
            seps[0] = ','; // both possible decimal seperators
            seps[1] = '.';
            // check if Thousand- group sign is available. If more than one sign, all left signs are removed
            int index = 0, cnt = 0;
            while (index > -1)  // count number of seperators
            {
                index = text.IndexOfAny(seps, index);  // look for next position of seps
                if (index > -1) { cnt++; index++; }
            }
            string newtext = text;
            if (cnt > 1)  // If more than one sign, all left signs are removed
            {
                string leftSign = text.Substring(text.IndexOfAny(seps), 1);  // what is the left sign?
                newtext = text.Replace(leftSign, "");// Remove all left signs
            }
            string help = newtext.Replace(comF, comR); // Change into correct decimal sep
            if (Double.TryParse(help, out number))
                nb = number;
            else MessageBox.Show(wrongDataFormat);

        }

        #endregion

        #region Variablen Achseneinteilung

        //Standarteinstellungen für die Achseneinteilung beim Initialisieren des Steuerelements
        double xMin = 0;
        double xMax = 10;
        double xGap = 1;
        double yMin = 0;  
        double yMax = 10;
        double y2Min=0;
        double y2Max=0;
        double yGap = 1;
        string loggehtnicht = "log only with pos x-values";
        //Faktor zur Umrechnung von Pixeln zu Koordinaten
  
        #endregion

        #region Kurven

 
        #endregion

        #region Kurvenfarben

        //Legt die Standardfarben der Kurven bei der Initialisierung fest
        Color ColorPen0 = Color.Blue;
        Color ColorPen1 = Color.Red;
        Color ColorPen2 = Color.Green;
        Color ColorPen3 = Color.Cyan;
        Color ColorPen4 = Color.Orange;
        Color ColorPen5 = Color.LightGreen;
        Color ColorPen6 = Color.Purple;
        Color ColorPen7 = Color.Pink;
        Color ColorPen8 = Color.Brown;
        Color ColorPen9 = Color.Yellow;

        //Zwischenspeicher der aktuellen Farbe beim Schwarz/Weiß Wechsel
        Color [] ColorBeforBW;

        #endregion

 
        #region Initialisierung 

        public Chart2D()
        {
            InitializeComponent();
            //Zusatzfenster einbinden
            frmname = new FormName(this);
            frmtitle = new FormTitle(this);
            frmscaling = new FormScaling(this);
            frmcutdialog = new FormCutDialog(this);
            frmColChange = new FormSColFX(this);
            //Englisch als Standardsprache
            english();
            //Kurvenfarben beim Start mit den Panels (Legende) verbinden 
            ColorBeforBW = new Color[10];      
            InitColor();    
            //Initialisieren des DataGridView
            dataGridViewIni();
            initchart();
        }

        private void initchart()
        {
            chart1.Legends[0].Enabled = false;
            chart1.ChartAreas[0].AxisY.MajorGrid.LineColor = Color.Gray;
            chart1.ChartAreas[0].AxisY.MinorGrid.LineColor = Color.LightGray;
            chart1.ChartAreas[0].AxisY2.MajorGrid.LineColor = Color.Blue;
            chart1.ChartAreas[0].AxisY2.MinorGrid.LineColor = Color.LightBlue;
            chart1.ChartAreas[0].AxisX.MajorGrid.LineColor = Color.Gray;
            chart1.ChartAreas[0].AxisX.MinorGrid.LineColor = Color.LightGray;
            chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = false;
            chart1.ChartAreas[0].AxisY2.MajorGrid.Enabled = false;
            chart1.ChartAreas[0].AxisX.ScaleView.ZoomReset();
            chart1.ChartAreas[0].AxisY.ScaleView.ZoomReset();
            chart1.ChartAreas[0].AxisY2.ScaleView.ZoomReset();
            for (int i = 0; i < 10; i++) IsY2local[i] = false;
        }

        #endregion

        #region Sprache

        #region Englisch

        private void english()
        {
            //UserControl1
            CurveNames[0] = "Curve 1";
            CurveNames[1] = "Curve 2";
            CurveNames[2] = "Curve 3";
            CurveNames[3] = "Curve 4";
            CurveNames[4] = "Curve 5";
            CurveNames[5] = "Curve 6";
            CurveNames[6] = "Curve 7";
            CurveNames[7] = "Curve 8";
            CurveNames[8] = "Curve 9";
            CurveNames[9] = "Curve 10";
            labelLegend.Text = "Legend";
            cutCurve0.Text = CurveNames[0];
            cutCurve1.Text = CurveNames[1];
            cutCurve2.Text = CurveNames[2];
            cutCurve3.Text = CurveNames[3];
            cutCurve4.Text = CurveNames[4];
            cutCurve5.Text = CurveNames[5];
            cutCurve6.Text = CurveNames[6];
            cutCurve7.Text = CurveNames[7];
            cutCurve8.Text = CurveNames[8];
            cutCurve9.Text = CurveNames[9];
            NameCurve0.Text = CurveNames[0];
            NameCurve1.Text = CurveNames[1];
            NameCurve2.Text = CurveNames[2];
            NameCurve3.Text = CurveNames[3];
            NameCurve4.Text = CurveNames[4];
            NameCurve5.Text = CurveNames[5];
            NameCurve6.Text = CurveNames[6];
            NameCurve7.Text = CurveNames[7];
            NameCurve8.Text = CurveNames[8];
            NameCurve9.Text = CurveNames[9];
            toolTip2.SetToolTip(buttonScaling, "manual scaling");
            toolTip2.SetToolTip(checkButtonXGrid, "XY-Major-grid");
            toolTip2.SetToolTip(checkButtonYGrid, "XY-Minor-grid");
            toolTip2.SetToolTip(buttonAutoScale, "autoscale curve");
            toolTip2.SetToolTip(checkButtonEditor, "toggle curve/table");
            toolTip2.SetToolTip(checkButtonLegend, "legend");
            toolTip2.SetToolTip(buttonAllClear, "clear all curves");
            toolTip2.SetToolTip(buttonLastClear, "clear last curve");
            toolTip2.SetToolTip(checkButtonPenScale, "thick lines");
            toolTip2.SetToolTip(buttonBackColor, "change background color");
            toolTip2.SetToolTip(checkButtonColorBlack, "select curve color");
            toolTip2.SetToolTip(buttonTitle, "top/bottom title");
            toolTip2.SetToolTip(buttonPrint, "print");
            toolTip2.SetToolTip(checkButtonZoom, "zoom");
            toolTip2.SetToolTip(buttonSave, "save file");
            toolTip2.SetToolTip(buttonLoad, "load file");
            toolTip2.SetToolTip(buttonInfo, "about Chart2D Bay");
            toolTip2.SetToolTip(butLinLog, "x-Axis linear or logarithmic");
            showKoord.Text = "show coordinates";
            cutGraph.Text = "cut curve";

            //FormName
            ChangeName = "Change name of ";
            ChangeName2 = "";
            frmname.labelName.Text = "Enter Curve name:";
            frmname.AbbruchButton.Text = "Cancel";

            //FormCutDialog
            frmcutdialog.Text = "Cut curve";
            frmcutdialog.labelCut.Text = "Cut curve at this position?";
            frmcutdialog.AbbruchButton.Text = "Cancel";

            //FormScaling
            frmscaling.Text = "Scaling";
            frmscaling.groupBoxX.Text = "X-axis";
            frmscaling.groupBoxY.Text = "Y-axis";
            frmscaling.Abbruchbutton.Text = "Cancel";
            frmscaling.gBY2Axis.Text = "Y2-axis";
            frmscaling.cBY2.Text = "2nd Y-Axis";

            //FormTitle
            frmtitle.Text = "Top/bottom title";
            frmtitle.labelTop.Text = "Top title:";
            frmtitle.labelBottom.Text = "Bottom title:";
            frmtitle.AbbruchButton.Text = "Cancel";

        }

        #endregion

        #region Deutsch

        private void german()
        {
            //UserControl1
            CurveNames[0] = "Kurve 1";
            CurveNames[1] = "Kurve 2";
            CurveNames[2] = "Kurve 3";
            CurveNames[3] = "Kurve 4";
            CurveNames[4] = "Kurve 5";
            CurveNames[5] = "Kurve 6";
            CurveNames[6] = "Kurve 7";
            CurveNames[7] = "Kurve 8";
            CurveNames[8] = "Kurve 9";
            CurveNames[9] = "Kurve 10";
            labelLegend.Text = "Legende";
            cutCurve0.Text = CurveNames[0];
            cutCurve1.Text = CurveNames[1];
            cutCurve2.Text = CurveNames[2];
            cutCurve3.Text = CurveNames[3];
            cutCurve4.Text = CurveNames[4];
            cutCurve5.Text = CurveNames[5];
            cutCurve6.Text = CurveNames[6];
            cutCurve7.Text = CurveNames[7];
            cutCurve8.Text = CurveNames[8];
            cutCurve9.Text = CurveNames[9];
            NameCurve0.Text = CurveNames[0];
            NameCurve1.Text = CurveNames[1];
            NameCurve2.Text = CurveNames[2];
            NameCurve3.Text = CurveNames[3];
            NameCurve4.Text = CurveNames[4];
            NameCurve5.Text = CurveNames[5];
            NameCurve6.Text = CurveNames[6];
            NameCurve7.Text = CurveNames[7];
            NameCurve8.Text = CurveNames[8];
            NameCurve9.Text = CurveNames[9];
            toolTip2.SetToolTip(buttonScaling, "Manuelle Skalierung");
            toolTip2.SetToolTip(checkButtonXGrid, "XY-Grid Grob");
            toolTip2.SetToolTip(checkButtonYGrid, "XY-Grid Fein");
            toolTip2.SetToolTip(buttonAutoScale, "Automatische Skalierung");
            toolTip2.SetToolTip(checkButtonEditor, "Dateneditor");
            toolTip2.SetToolTip(checkButtonLegend, "Legende ein-/ausblenden");
            toolTip2.SetToolTip(buttonAllClear, "Alle Kurven löschen");
            toolTip2.SetToolTip(buttonLastClear, "Letzte Kurve löschen");
            toolTip2.SetToolTip(checkButtonPenScale, "Doppelte Kurvenstärke");
            toolTip2.SetToolTip(buttonBackColor, "Hintergrundfarbe ändern");
            toolTip2.SetToolTip(checkButtonColorBlack, "Wähle Kurvenfarbe");
            toolTip2.SetToolTip(buttonTitle, "Über-/Unterschrift");
            toolTip2.SetToolTip(buttonPrint, "Drucken");
            toolTip2.SetToolTip(checkButtonZoom, "Zoom");
            toolTip2.SetToolTip(buttonSave, "Datei speichern");
            toolTip2.SetToolTip(buttonLoad, "Datei laden");
            toolTip2.SetToolTip(buttonInfo, "Über Chart2D");
            toolTip2.SetToolTip(butLinLog, "x-Achse linear or logarithmisch");
            showKoord.Text = "Koordinaten anzeigen";
            cutGraph.Text = "Kurve abschneiden";
            loggehtnicht = "log geht nur mit positiven x-Werten";

            //FormName
            ChangeName = "Name von ";
            ChangeName2 = " andern";
            frmname.labelName.Text = "Name eingeben:";
            frmname.AbbruchButton.Text = "Abbrechen";

            //FormCutDialog
            frmcutdialog.Text = "Kurve abschneiden";
            frmcutdialog.labelCut.Text = "Kurve hier abschneiden?";
            frmcutdialog.AbbruchButton.Text = "Abbrechen";

            //FormScaling
            frmscaling.Text = "Skalierung";
            frmscaling.groupBoxX.Text = "X-Achse";
            frmscaling.groupBoxY.Text = "Y-Achse";
            frmscaling.Abbruchbutton.Text = "Abbrechen";
            frmscaling.gBY2Axis.Text = "Y2-Achse";
            frmscaling.cBY2.Text = "2te Y-Achse";
            //frmscaling.cBY2AutoScale.Text = "Geändert mit Autoscale";
            frmscaling.DoubleGapbutton.Text = "Raster *2";

            //FormTitle
            frmtitle.Text = "Über-/Unterschrift";
            frmtitle.labelTop.Text = "Überschrift:";
            frmtitle.labelBottom.Text = "Unterschrift:";
            frmtitle.AbbruchButton.Text = "Abbrechen";

        }

        #endregion

        #endregion

 
        #region Public-Methoden

        #region Setzen von Y2- Eigenschaft

        public void setY2(int nr, bool value)
        {
             // geht mit ISY2[] irgendwie nicht
            if (nr < chart1.Series.Count)
                if (value)
                {
                    chart1.ChartAreas[0].AxisY2.Enabled = System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True;
                    chart1.Series[nr].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary;
                    IsY2[nr] = true;
                }
                else
                {
                    chart1.Series[nr].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Primary;
                    IsY2[nr] = false;
                }
        }


        #endregion

        #region Einlesen der Koordinaten

        /// <summary>
        /// Legt die Kurvennummer fest sowie die dazugehörigen Koordinaten des Punktes. Es ist eine maximale Anzahl von 10 Kurven möglich.
        /// </summary>
        /// <param name="nr">Kurvennummer (0-9)</param>
        /// <param name="x">X-Koordinate</param>
        /// <param name="y">Y-Koordinate</param>
        public void setPoint(int nr, double x, double y)
        {
            if (y > 1e28) y = 1e28; // Begrenzung ab 7.18, da sonst Chart mit rotem Kreuz
            if (y < -1e28) y = -1e28;
            
            if (nr < 10)  // max 10 Kurven sonst tue nix
            {

                chart1.Visible = true;
                while (chart1.Series.Count <= nr) // soviele Curven erzeugen, dass max 10 kurven da
                {
                    int nb = chart1.Series.Count;
                    chart1.Series.Add(nb.ToString()+CurveNames[nb]);
                    chart1.Series[nb].ChartType = SeriesChartType.Line;
                    if (IsY2local[nb])
                    {
                        chart1.Series[nb].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary;
                        chart1.ChartAreas[0].AxisY2.Enabled = System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True;
                    }
                }
                chart1.Series[0].ChartType = SeriesChartType.Line; // Kurve 0 ist immer da     
                switch (nr)
                {
                    case 0: 
                        //Kurvennamen und Farbe übergeben
                        NameCurve0.Text = CurveNames[0];
                        ColorCurve0.BackColor = ColorPen0;
                        chart1.Series[0].Color = ColorPen0;
                        chart1.Series[0].LegendText = CurveNames[0];
                        cutCurve0.Text = CurveNames[0];
                        cutCurve0.ForeColor = ColorPen0;
                        //Kurve in Legende und Kontextmenü sichtbar machen
                        NameCurve0.Visible = true;
                        ColorCurve0.Visible = true;
                        cutCurve0.Visible = true;
                        //Spalten in DataGridView sichtbar machen
                        dataGridView1.Columns[0].Visible = true;
                        dataGridView1.Columns[1].Visible = true;
                        //Anzahl der Punkte übergeben
                        
                        chart1.Series[0].Points.AddXY(x, y);
                        break; 
                    case 1: 
                        NameCurve1.Text = CurveNames[1];
                        ColorCurve1.BackColor = ColorPen1;
                        chart1.Series[1].Color = ColorPen1;
                        chart1.Series[1].LegendText = CurveNames[1];
                        cutCurve1.Text = CurveNames[1];
                        cutCurve1.ForeColor = ColorPen1;
                        NameCurve1.Visible = true;
                        ColorCurve1.Visible = true;
                        cutCurve1.Visible = true;
                        dataGridView1.Columns[2].Visible = true;
                        dataGridView1.Columns[3].Visible = true;
                        chart1.Series[1].Points.AddXY(x, y);
                        break;
                    case 2: 
                         NameCurve2.Text = CurveNames[2];
                        ColorCurve2.BackColor = ColorPen2;
                        chart1.Series[2].Color = ColorPen2;
                        chart1.Series[2].LegendText = CurveNames[2];
                        cutCurve2.Text = CurveNames[2];
                        cutCurve2.ForeColor = ColorPen2;
                        NameCurve2.Visible = true;
                        ColorCurve2.Visible = true;
                        cutCurve2.Visible = true;
                        dataGridView1.Columns[4].Visible = true;
                        dataGridView1.Columns[5].Visible = true;
                        chart1.Series[2].Points.AddXY(x, y);
                         break;
                    case 3: 
                        NameCurve3.Text = CurveNames[3];
                        ColorCurve3.BackColor = ColorPen3;
                        chart1.Series[3].Color = ColorPen3;
                        chart1.Series[3].LegendText = CurveNames[3];
                        cutCurve3.Text = CurveNames[3];
                        cutCurve3.ForeColor = ColorPen3;
                        NameCurve3.Visible = true;
                        ColorCurve3.Visible = true;
                        cutCurve3.Visible = true;
                        dataGridView1.Columns[6].Visible = true;
                        dataGridView1.Columns[7].Visible = true;
                        chart1.Series[3].Points.AddXY(x, y);
                         break;
                    case 4: 
                         NameCurve4.Text = CurveNames[4];
                        ColorCurve4.BackColor = ColorPen4;
                        chart1.Series[4].Color = ColorPen4;
                        chart1.Series[4].LegendText = CurveNames[4];
                        cutCurve4.Text = CurveNames[4];
                        cutCurve4.ForeColor = ColorPen4;
                        NameCurve4.Visible = true;
                        ColorCurve4.Visible = true;
                        cutCurve4.Visible = true;
                        dataGridView1.Columns[8].Visible = true;
                        dataGridView1.Columns[9].Visible = true;
                        chart1.Series[4].Points.AddXY(x, y);
                         break;
                    case 5: 
                        NameCurve5.Text = CurveNames[5];
                        ColorCurve5.BackColor = ColorPen5;
                        chart1.Series[5].Color = ColorPen5;
                        chart1.Series[5].LegendText = CurveNames[5];
                        cutCurve5.Text = CurveNames[5];
                        cutCurve5.ForeColor = ColorPen5;
                        NameCurve5.Visible = true;
                        ColorCurve5.Visible = true;
                        cutCurve5.Visible = true;
                        dataGridView1.Columns[10].Visible = true;
                        dataGridView1.Columns[11].Visible = true;
                        chart1.Series[5].Points.AddXY(x, y);
                        break;
                    case 6: 
                        NameCurve6.Text = CurveNames[6];
                        ColorCurve6.BackColor = ColorPen6;
                        chart1.Series[6].Color = ColorPen6;
                        chart1.Series[6].LegendText = CurveNames[6];
                        cutCurve6.Text = CurveNames[6];
                        cutCurve6.ForeColor = ColorPen6;
                        NameCurve6.Visible = true;
                        ColorCurve6.Visible = true;
                        cutCurve6.Visible = true;
                        dataGridView1.Columns[12].Visible = true;
                        dataGridView1.Columns[13].Visible = true;
                        chart1.Series[6].Points.AddXY(x, y);
                         break;
                    case 7: 
                         NameCurve7.Text = CurveNames[7];
                        ColorCurve7.BackColor = ColorPen7;
                        chart1.Series[7].Color = ColorPen7;
                        chart1.Series[7].LegendText = CurveNames[7];
                        cutCurve7.Text = CurveNames[7];
                        cutCurve7.ForeColor = ColorPen7;
                        NameCurve7.Visible = true;
                        ColorCurve7.Visible = true;
                        cutCurve7.Visible = true;
                        dataGridView1.Columns[14].Visible = true;
                        dataGridView1.Columns[15].Visible = true;
                        chart1.Series[7].Points.AddXY(x, y);
                         break;
                    case 8: 
                        NameCurve8.Text = CurveNames[8];
                        ColorCurve8.BackColor = ColorPen8;
                        chart1.Series[8].Color = ColorPen8;
                        chart1.Series[8].LegendText = CurveNames[8];
                        cutCurve8.Text = CurveNames[8];
                        cutCurve8.ForeColor = ColorPen8;
                        NameCurve8.Visible = true;
                        ColorCurve8.Visible = true;
                        cutCurve8.Visible = true;
                        dataGridView1.Columns[16].Visible = true;
                        dataGridView1.Columns[17].Visible = true;
                        chart1.Series[8].Points.AddXY(x, y);
                        break;
                    case 9: 
                         NameCurve9.Text = CurveNames[9];
                        chart1.Series[9].Color = ColorPen9;
                        chart1.Series[9].LegendText = CurveNames[9];
                        ColorCurve9.BackColor = ColorPen9;
                        cutCurve9.Text = CurveNames[9];
                        cutCurve9.ForeColor = ColorPen9;
                        NameCurve9.Visible = true;
                        ColorCurve9.Visible = true;
                        cutCurve9.Visible = true;
                        dataGridView1.Columns[18].Visible = true;
                        dataGridView1.Columns[19].Visible = true;
                        chart1.Series[9].Points.AddXY(x, y);
                         break;
                    default: break;
                }
                pointsCount[nr] = chart1.Series[nr].Points.Count;
            }
        }

        #endregion

        #region Starten des Zeichenvorgangs

        /// <summary>
        /// Startet den Zeichenvorgang
        /// </summary>
        public void startDrawing()
        {
            //PictureBox neu zeichnen
            //GraphPBox.Invalidate();
            //Werte an das DataGridView übergeben
            //setEData(); Füllt Datagrid neu
            chart1.Invalidate();
        }

        #endregion

        #region Echtzeitzeichnen

        /// <summary>
        /// Legt die Kurvennummer fest sowie die dazugehörigen Koordinaten des Punktes. Es ist eine maximale Anzahl von 10 Kurven möglich.
        /// Hierbei wird die Kurve nach jedem hinzugefügten Punkt neu gezeichnet.
        /// </summary>
        /// <param name="nr">Kurvennummer (0-9)</param>
        /// <param name="x">X-Koordinate</param>
        /// <param name="y">Y-Koordinate</param>
        public void realTimeChart(int nr, double x, double y)
        {
            setPoint(nr, x, y);
//           setEData();
//            GraphPBox.Invalidate();
            chart1.Invalidate();
        }

        #endregion

        #region ScopeMode
        private void scopeModeSetPoint(int nr, double x, double y)
        {
            if (y > 1e28) y = 1e28; // Begrenzung ab 7.18, da sonst Chart mit rotem Kreuz
            if (y < -1e28) y = -1e28;

            if (nr < 10)  // max 10 Kurven sonst tue nix
            {

                chart1.Visible = true;
                while (chart1.Series.Count <= nr) // soviele Curven erzeugen, dass max 10 kurven da
                {
                    int nb = chart1.Series.Count;
                    chart1.Series.Add(nb.ToString() + CurveNames[nb]);
                    chart1.Series[nb].ChartType = SeriesChartType.Line;
                    if (IsY2local[nb])
                    {
                        chart1.Series[nb].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary;
                        chart1.ChartAreas[0].AxisY2.Enabled = System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True;
                    }
                }
                chart1.Series[0].ChartType = SeriesChartType.Line; // Kurve 0 ist immer da     
                switch (nr)
                {
                    case 0:
                        //Kurvennamen und Farbe übergeben
                        NameCurve0.Text = CurveNames[0];
                        ColorCurve0.BackColor = ColorPen0;
                        chart1.Series[0].Color = ColorPen0;
                        chart1.Series[0].LegendText = CurveNames[0];
                        cutCurve0.Text = CurveNames[0];
                        cutCurve0.ForeColor = ColorPen0;
                        //Kurve in Legende und Kontextmenü sichtbar machen
                        NameCurve0.Visible = true;
                        ColorCurve0.Visible = true;
                        cutCurve0.Visible = true;
                        //Spalten in DataGridView sichtbar machen
                        dataGridView1.Columns[0].Visible = true;
                        dataGridView1.Columns[1].Visible = true;
                        //Anzahl der Punkte übergeben

                        chart1.Series[0].Points.AddXY(x, y);
                        break;
                    case 1:
                        NameCurve1.Text = CurveNames[1];
                        ColorCurve1.BackColor = ColorPen1;
                        chart1.Series[1].Color = ColorPen1;
                        chart1.Series[1].LegendText = CurveNames[1];
                        cutCurve1.Text = CurveNames[1];
                        cutCurve1.ForeColor = ColorPen1;
                        NameCurve1.Visible = true;
                        ColorCurve1.Visible = true;
                        cutCurve1.Visible = true;
                        dataGridView1.Columns[2].Visible = true;
                        dataGridView1.Columns[3].Visible = true;
                        chart1.Series[1].Points.AddXY(x, y);
                        break;
                    case 2:
                        NameCurve2.Text = CurveNames[2];
                        ColorCurve2.BackColor = ColorPen2;
                        chart1.Series[2].Color = ColorPen2;
                        chart1.Series[2].LegendText = CurveNames[2];
                        cutCurve2.Text = CurveNames[2];
                        cutCurve2.ForeColor = ColorPen2;
                        NameCurve2.Visible = true;
                        ColorCurve2.Visible = true;
                        cutCurve2.Visible = true;
                        dataGridView1.Columns[4].Visible = true;
                        dataGridView1.Columns[5].Visible = true;
                        chart1.Series[2].Points.AddXY(x, y);
                        break;
                    case 3:
                        NameCurve3.Text = CurveNames[3];
                        ColorCurve3.BackColor = ColorPen3;
                        chart1.Series[3].Color = ColorPen3;
                        chart1.Series[3].LegendText = CurveNames[3];
                        cutCurve3.Text = CurveNames[3];
                        cutCurve3.ForeColor = ColorPen3;
                        NameCurve3.Visible = true;
                        ColorCurve3.Visible = true;
                        cutCurve3.Visible = true;
                        dataGridView1.Columns[6].Visible = true;
                        dataGridView1.Columns[7].Visible = true;
                        chart1.Series[3].Points.AddXY(x, y);
                        break;
                    case 4:
                        NameCurve4.Text = CurveNames[4];
                        ColorCurve4.BackColor = ColorPen4;
                        chart1.Series[4].Color = ColorPen4;
                        chart1.Series[4].LegendText = CurveNames[4];
                        cutCurve4.Text = CurveNames[4];
                        cutCurve4.ForeColor = ColorPen4;
                        NameCurve4.Visible = true;
                        ColorCurve4.Visible = true;
                        cutCurve4.Visible = true;
                        dataGridView1.Columns[8].Visible = true;
                        dataGridView1.Columns[9].Visible = true;
                        chart1.Series[4].Points.AddXY(x, y);
                        break;
                    case 5:
                        NameCurve5.Text = CurveNames[5];
                        ColorCurve5.BackColor = ColorPen0;
                        chart1.Series[5].Color = ColorPen0;
                        chart1.Series[5].LegendText = CurveNames[5];
                        cutCurve5.Text = CurveNames[5];
                        cutCurve5.ForeColor = ColorPen0;
                        NameCurve5.Visible = true;
                        ColorCurve5.Visible = true;
                        cutCurve5.Visible = true;
                        dataGridView1.Columns[10].Visible = true;
                        dataGridView1.Columns[11].Visible = true;
                        chart1.Series[5].Points.AddXY(x, y);
                        break;
                    case 6:
                        NameCurve6.Text = CurveNames[6];
                        ColorCurve6.BackColor = ColorPen1;
                        chart1.Series[6].Color = ColorPen1;
                        chart1.Series[6].LegendText = CurveNames[6];
                        cutCurve6.Text = CurveNames[6];
                        cutCurve6.ForeColor = ColorPen1;
                        NameCurve6.Visible = true;
                        ColorCurve6.Visible = true;
                        cutCurve6.Visible = true;
                        dataGridView1.Columns[12].Visible = true;
                        dataGridView1.Columns[13].Visible = true;
                        chart1.Series[6].Points.AddXY(x, y);
                        break;
                    case 7:
                        NameCurve7.Text = CurveNames[7];
                        ColorCurve7.BackColor = ColorPen2;
                        chart1.Series[7].Color = ColorPen2;
                        chart1.Series[7].LegendText = CurveNames[7];
                        cutCurve7.Text = CurveNames[7];
                        cutCurve7.ForeColor = ColorPen2;
                        NameCurve7.Visible = true;
                        ColorCurve7.Visible = true;
                        cutCurve7.Visible = true;
                        dataGridView1.Columns[14].Visible = true;
                        dataGridView1.Columns[15].Visible = true;
                        chart1.Series[7].Points.AddXY(x, y);
                        break;
                    case 8:
                        NameCurve8.Text = CurveNames[8];
                        ColorCurve8.BackColor = ColorPen3;
                        chart1.Series[8].Color = ColorPen3;
                        chart1.Series[8].LegendText = CurveNames[8];
                        cutCurve8.Text = CurveNames[8];
                        cutCurve8.ForeColor = ColorPen3;
                        NameCurve8.Visible = true;
                        ColorCurve8.Visible = true;
                        cutCurve8.Visible = true;
                        dataGridView1.Columns[16].Visible = true;
                        dataGridView1.Columns[17].Visible = true;
                        chart1.Series[8].Points.AddXY(x, y);
                        break;
                    case 9:
                        NameCurve9.Text = CurveNames[9];
                        chart1.Series[9].Color = ColorPen4;
                        chart1.Series[9].LegendText = CurveNames[9];
                        ColorCurve9.BackColor = ColorPen4;
                        cutCurve9.Text = CurveNames[9];
                        cutCurve9.ForeColor = ColorPen4;
                        NameCurve9.Visible = true;
                        ColorCurve9.Visible = true;
                        cutCurve9.Visible = true;
                        dataGridView1.Columns[18].Visible = true;
                        dataGridView1.Columns[19].Visible = true;
                        chart1.Series[9].Points.AddXY(x, y);
                        break;
                    default: break;
                }
                pointsCount[nr] = chart1.Series[nr].Points.Count;
            }
        }

        public void initializeScopeMode()
        {
            for (int i = 0; i < 5; i++)
            {

                scopeModeSwitch[i] = false;
            }
            for (int i = 0; i < 10; i++)
            {
                scopeModeSetPoint(i, 0, 0);
            }
            time = new Stopwatch();
            time.Start();
            start_time = time.ElapsedTicks;
        }

        public void scopeChart(int nr, double y)
        {
            actual_time = time.ElapsedTicks;
            scopeModeXTime = (actual_time - start_time) / (double)Stopwatch.Frequency;
            if (nr <= 4)
            {
                if (scopeModeSwitch[nr])
                {
                    scopeModeSetPoint(nr + 5, scopeModeXTime, y);
                    if (chart1.Series.Count > nr + 5)
                    {
                        if (chart1.Series[nr].Points.Count > 0)
                        {
                            chart1.Series[nr].Points.RemoveAt(0);
                        }
                    }

                    if (scopeModeXTime >= XMax)
                    {
                        time.Restart();
                        for (int i1 = 0; i1 < 5; i1++)
                        {
                            chart1.Series[i1].Points.Clear();
                            scopeModeSwitch[i1] = false;
                        }
                    }
                }
                else
                {
                    scopeModeSetPoint(nr, scopeModeXTime, y);
                    if (chart1.Series.Count > nr + 5)
                    {
                        if (chart1.Series[nr + 5].Points.Count > 0)
                        {
                            chart1.Series[nr + 5].Points.RemoveAt(0);
                        }
                    }

                    if (scopeModeXTime >= XMax)
                    {
                        time.Restart();
                        for (int i1 = 0; i1 < 5; i1++)
                        {
                            chart1.Series[i1 + 5].Points.Clear();
                            scopeModeSwitch[i1] = true;
                        }
                    }
                }
                chart1.Invalidate();
            }
        }


        #endregion

        #region Auslesen der Koordinaten

        #region Alle Koordinatenpunkte eines Graphen

        /// <summary>
        /// Liefert ein zweidimensionales Array mit den X und Y Koordinaten der gewünschten Kurve.
        /// </summary>
        /// <param name="nr">Kurvennummer (0-9)</param>
        /// <returns>Zweidimensionales Array mit allen X und Y Koordinaten der Kurve</returns>
        public double[,] getPoints(int nr)
        {
            //Zweidimensionales Array mit X und Y Werten
            double[,] points;
            if (nr < chart1.Series.Count)
            {
                points = new double[chart1.Series[nr].Points.Count, 2]; //Initialisierung: Zwei Spalten und Bestimmung der Zeilenanzahl (Kurvenpunkte)
                for (int i = 0; i < chart1.Series[nr].Points.Count; i++)
                {
                    points[i, 0] = chart1.Series[nr].Points[i].XValue;  //X Wert in erste Spalte speichern
                    points[i, 1] = chart1.Series[nr].Points[i].YValues[0];  //Y Wert in zweite Spalte speichern
                }

            }
            else points = new double[0,0];

            return points; //Zweidimensionales Array mit den Kurvenpunkten zurückliefern
        }

        #endregion

        #region Einzelnen Koordinatenpunkt eines Graphen

        /// <summary>
        /// Liefert einen einzelnen Punkt (zweidimensionales Array) mit den X und Y Koordinaten an der angegebenen Stelle.
        /// </summary>
        /// <param name="nr">Kurvennummer (0-9)</param>
        /// <param name="position">position">Stelle im Kurvenarray </param>
        /// <returns>Array mit der X und Y Koordinate</returns>
        public double[] getPoint(int nr, int position)
        {
            //Einfaches Array mit dem Koordinatenpunkt
            double[] point = new double[2]; //Initialisierung des Arrays (Zwei Werte)

            if (nr < chart1.Series.Count)
            {
                point[0] = chart1.Series[nr].Points[position].XValue; //erster Wert X
                point[1] = chart1.Series[nr].Points[position].YValues[0]; //zweiter Wert Y
            }
            

            return point; //Array mit dem Koordinatenpunkt zurückliefern
        }

        #endregion

        #endregion

        #region Löschen der Graphen

        #region Alle Graphen löschen

        /// <summary>
        /// Löscht alle Kurven und setzt alle Farben und Namen auf die Standardwerte zurück.
        /// </summary>
        public void clearAll()
        {

            chart1.ChartAreas[0].AxisX.IsLogarithmic = false; // must be false otherwise red Cross !!
            if (chart1.Series.Count > 0)
                chart1.Series.Clear();
            chart1.Invalidate();
            chart1.Visible = false;
            //Kurvenzähler zurücksetzen

            
            //Farben auf Standard setzen
            //ColorPen0 = Color.Blue;
            //ColorPen1 = Color.Red;
            //ColorPen2 = Color.Green;
            //ColorPen3 = Color.Cyan;
            //ColorPen4 = Color.Orange;
            //ColorPen5 = Color.LightGreen;
            //ColorPen6 = Color.Purple;
            //ColorPen7 = Color.Pink;
            //ColorPen8 = Color.Brown;
            //ColorPen9 = Color.Yellow;

            //Namen auf Standard setzen
            CurveNames[0] = "Curve 1";
            CurveNames[1] = "Curve 2";
            CurveNames[2] = "Curve 3";
            CurveNames[3] = "Curve 4";
            CurveNames[4] = "Curve 5";
            CurveNames[5] = "Curve 6";
            CurveNames[6] = "Curve 7";
            CurveNames[7] = "Curve 8";
            CurveNames[8] = "Curve 9";
            CurveNames[9] = "Curve 10";

            //Kurven in Legende und im Kontextmenü "unsichtbar" machen
            NameCurve0.Visible = false;
            ColorCurve0.Visible = false;
            cutCurve0.Visible = false;
            NameCurve1.Visible = false;
            ColorCurve1.Visible = false;
            cutCurve1.Visible = false;
            NameCurve2.Visible = false;
            ColorCurve2.Visible = false;
            cutCurve2.Visible = false;
            NameCurve3.Visible = false;
            ColorCurve3.Visible = false;
            cutCurve3.Visible = false;
            NameCurve4.Visible = false;
            ColorCurve4.Visible = false;
            cutCurve4.Visible = false;
            NameCurve5.Visible = false;
            ColorCurve5.Visible = false;
            cutCurve5.Visible = false;
            NameCurve6.Visible = false;
            ColorCurve6.Visible = false;
            cutCurve6.Visible = false;
            NameCurve7.Visible = false;
            ColorCurve7.Visible = false;
            cutCurve7.Visible = false;
            NameCurve8.Visible = false;
            ColorCurve8.Visible = false;
            cutCurve8.Visible = false;
            NameCurve9.Visible = false;
            ColorCurve9.Visible = false;
            cutCurve9.Visible = false;

            //Zeilen in DataGridView löschen
            dataGridView1.Rows.Clear();

            //Spalten in DataGridView auf "unsichtbar" stellen
            for (int i = 0; i <= 19; i++) dataGridView1.Columns[i].Visible = false;

            //Anzahl der Punkte auf 0
            for (int i = 0; i <= 9; i++) pointsCount[i] = 0;

            //PictureBox neu zeichnen
//            GraphPBox.Invalidate();
        }

        #endregion

        #region Letzten Graph löschen

        /// <summary>
        /// Löscht die zuletzt hinzugefügte Kurve. 
        /// </summary>
        public void clearLast()
        {
            chart1.Visible = true;
            switch (chart1.Series.Count-1) //Kurvenauswahl
            {
                case 0: 
                    //Standardfarbe und Name zurücksetzen und auf "unsichtbar" stellen
                    //ColorPen0 = Color.Blue;
                    chart1.ChartAreas[0].AxisX.IsLogarithmic = false; // must be false otherwise red Cross !!
                    CurveNames[0] = "Curve 1";
                    NameCurve0.Visible = false;
                    ColorCurve0.Visible = false;
                    cutCurve0.Visible = false;
                    dataGridView1.Columns[0].Visible = false;
                    dataGridView1.Columns[1].Visible = false;
                    pointsCount[0] = 0; //Anzahl der Punkte in der Kurve auf 0
                    chart1.Series.RemoveAt(0);
                    chart1.Visible = false;
                    break;
                case 1: 
                    //ColorPen1 = Color.Red;
                    CurveNames[1] = "Curve 2";
                    NameCurve1.Visible = false;
                    ColorCurve1.Visible = false;
                    cutCurve1.Visible = false;
                    dataGridView1.Columns[2].Visible = false;
                    dataGridView1.Columns[3].Visible = false;
                    pointsCount[1] = 0;
                    chart1.Series.RemoveAt(1);
                    chart1.Invalidate();
                    //  for (int i = rowCount - (rowCount - Curve0X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 2: 
                    //ColorPen2 = Color.Green;
                    CurveNames[2] = "Curve 3";
                    NameCurve2.Visible = false;
                    ColorCurve2.Visible = false;
                    cutCurve2.Visible = false;
                    dataGridView1.Columns[4].Visible = false;
                    dataGridView1.Columns[5].Visible = false;
                    pointsCount[2] = 0;
                    chart1.Series.RemoveAt(2);
                    chart1.Invalidate();
                    //  for (int i = rowCount - (rowCount - Curve1X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 3: 
                    //ColorPen3 = Color.Cyan;
                    CurveNames[3] = "Curve 4";
                    NameCurve3.Visible = false;
                    ColorCurve3.Visible = false;
                    cutCurve3.Visible = false;
                    dataGridView1.Columns[6].Visible = false;
                    dataGridView1.Columns[7].Visible = false;
                    pointsCount[3] = 0;
                    chart1.Series.RemoveAt(3);
                    chart1.Invalidate();

                    // for (int i = rowCount - (rowCount - Curve2X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 4: 
                    //ColorPen4 = Color.Orange;
                    CurveNames[4] = "Curve 5";
                    NameCurve4.Visible = false;
                    ColorCurve4.Visible = false;
                    cutCurve4.Visible = false;
                    dataGridView1.Columns[8].Visible = false;
                    dataGridView1.Columns[9].Visible = false;
                    pointsCount[4] = 0;
                    chart1.Series.RemoveAt(4);
                    chart1.Invalidate();

                    //  for (int i = rowCount - (rowCount - Curve3X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 5: 
                    //ColorPen5 = Color.LightGreen;
                    CurveNames[5] = "Curve 6";
                    NameCurve5.Visible = false;
                    ColorCurve5.Visible = false;
                    cutCurve5.Visible = false;
                    dataGridView1.Columns[10].Visible = false;
                    dataGridView1.Columns[11].Visible = false;
                    pointsCount[5] = 0;
                    chart1.Series.RemoveAt(5);
                    chart1.Invalidate();
                   //  for (int i = rowCount - (rowCount - Curve4X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 6: 
                    //ColorPen6 = Color.Purple;
                    CurveNames[6] = "Curve 7";
                    NameCurve6.Visible = false;
                    ColorCurve6.Visible = false;
                    cutCurve6.Visible = false;
                    dataGridView1.Columns[12].Visible = false;
                    dataGridView1.Columns[13].Visible = false;
                    pointsCount[6] = 0;
                    chart1.Series.RemoveAt(6);
                    chart1.Invalidate();
                   //  for (int i = rowCount - (rowCount - Curve5X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 7: 
                    //ColorPen7 = Color.Pink;
                    CurveNames[7] = "Curve 8";
                    NameCurve7.Visible = false;
                    ColorCurve7.Visible = false;
                    cutCurve7.Visible = false;
                    dataGridView1.Columns[14].Visible = false;
                    dataGridView1.Columns[15].Visible = false;
                     pointsCount[7] = 0;
                    chart1.Series.RemoveAt(7);
                    chart1.Invalidate();
                    // for (int i = rowCount - (rowCount - Curve6X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 8: 
                    //ColorPen8 = Color.Brown;
                    CurveNames[8] = "Curve 9";
                    NameCurve8.Visible = false;
                    ColorCurve8.Visible = false;
                    cutCurve8.Visible = false;
                    dataGridView1.Columns[16].Visible = false;
                    dataGridView1.Columns[17].Visible = false;
                    pointsCount[8] = 0;
                    chart1.Series.RemoveAt(8);
                    chart1.Invalidate();
                    // for (int i = rowCount - (rowCount - Curve7X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                case 9: 
                    //ColorPen9 = Color.Yellow;
                    CurveNames[9] = "Curve 10";
                    NameCurve9.Visible = false;
                    ColorCurve9.Visible = false;
                    cutCurve9.Visible = false;
                    dataGridView1.Columns[18].Visible = false;
                    dataGridView1.Columns[19].Visible = false;
                    pointsCount[9] = 0;
                    chart1.Series.RemoveAt(9);
                    chart1.Invalidate();
                   //for (int i = rowCount - (rowCount - Curve8X.Count); i < rowCount; i++) dataGridView1.Rows[i].Visible = false;
                    break;
                default: break;
            }
            //DataGridView anpassen
            //setEData();
            //PictureBox neu zeichnen
            //GraphPBox.Invalidate();
        }

        #endregion

        #endregion

        #region Aktualisieren der Graphennamen

        /// <summary>
        /// Aktualisiert die Namen der Kurven in der Legende und im Kontextmenü.
        /// Muss nach dem Ändern des Namens im CurveNames[] Array aufgerufen werden. 
        /// </summary>
        public void updateNames()
        {
            //Name übergeben
            NameCurve0.Text = CurveNames[0];
            cutCurve0.Text = CurveNames[0];

            NameCurve1.Text = CurveNames[1];
            cutCurve1.Text = CurveNames[1];

            NameCurve2.Text = CurveNames[2];
            cutCurve2.Text = CurveNames[2];

            NameCurve3.Text = CurveNames[3];
            cutCurve3.Text = CurveNames[3];

            NameCurve4.Text = CurveNames[4];
            cutCurve4.Text = CurveNames[4];

            NameCurve5.Text = CurveNames[5];
            cutCurve5.Text = CurveNames[5];

            NameCurve6.Text = CurveNames[6];
            cutCurve6.Text = CurveNames[6];

            NameCurve7.Text = CurveNames[7];
            cutCurve7.Text = CurveNames[7];

            NameCurve8.Text = CurveNames[8];
            cutCurve8.Text = CurveNames[8];

            NameCurve9.Text = CurveNames[9];
            cutCurve9.Text = CurveNames[9];

            for (int i = 0; i < 10; i++)
                if (chart1.Series.Count > i)
                    chart1.Series[i].LegendText = CurveNames[i];
        }

        #endregion

        #endregion

        #region Dateneditor

        #region Initialisieren des DataGridView

        private void dataGridViewIni()
        {
            //Maximale Anzahl der Spalten festlegen
            dataGridView1.ColumnCount = 20;

            //Grundeinsellungen des DataGridView
            dataGridView1.SelectionMode = DataGridViewSelectionMode.CellSelect; //Nur Zellen und keine Spaltenauswahl und Zeilenauswahl
            dataGridView1.MultiSelect = false; //Nur eine Zelle zur Zeit auswählbar
            dataGridView1.DefaultCellStyle.SelectionBackColor = Color.LightSkyBlue; //Hintergrundfarbe bei Auswahl
            dataGridView1.AllowUserToOrderColumns = false; //Sortierung der Spalten deaktiviert
            dataGridView1.AllowUserToResizeRows = false; //Größenänderung der Zeilen deaktiviert

            //X-Achse: Schreibgeschützt und Farbe grau
            for (int i = 0; i <= 18; i += 2)
            {
                dataGridView1.Columns[i].ReadOnly = true;
                dataGridView1.Columns[i].DefaultCellStyle.BackColor = Color.LightGray;
            }

            //Automatische Sortierung deaktivieren und Spalten beim Initialisieren nicht sichtbar
            for (int i = 0; i <= 19; i++)
            {
                dataGridView1.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
                dataGridView1.Columns[i].Visible = false;
            }
        }

        #endregion

        #region Übergabe von Daten an das DataGridView

 

        private void setEData()
        {
            //Spaltenüberschrift

            //Alle Zeilen löschen
            dataGridView1.Rows.Clear();
            for (int i = 0; i <= 19; i++)
                 dataGridView1.Columns[i].Visible = false;

            for (int i = 0; i <= 19; i++)
                if (i<chart1.Series.Count*2 )
                dataGridView1.Columns[i].Visible = true;


            //Maximale Koordinatenanzahl an die Zeilenanzahl übergeben
            if (chart1.Series.Count > 0)
            {
                rowCount = chart1.Series[0].Points.Count;
                dataGridView1.Columns[0].Name = chart1.Series[0].Name + ": X";
                dataGridView1.Columns[1].Name = chart1.Series[0].Name + ": Y";
                for (int i = 0; i <= chart1.Series[0].Points.Count - 1; i++)
                {
                    //Zeile hinzufügen
                    dataGridView1.Rows.Add();
                    //Nummerierung der einzelnen Zeilen
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    //X- und Y-Wert in die jeweilige Spalte schreiben
                    dataGridView1[0, i].Value = chart1.Series[0].Points[i].XValue.ToString("g6");
                    dataGridView1[1, i].Value = chart1.Series[0].Points[i].YValues[0].ToString("g6");
                }
            }
            //Falls die nachfolgende Kurve mehr Zeilen besitzt
            if (chart1.Series.Count > 1)
            {
                dataGridView1.Columns[2].Name = chart1.Series[1].Name + ": X";
                dataGridView1.Columns[3].Name = chart1.Series[1].Name + ": Y";

                if (rowCount < chart1.Series[1].Points.Count)
                {
                    //Zusätzliche Zeilenanzahl hinzufügen
                    dataGridView1.Rows.Add(chart1.Series[1].Points.Count - rowCount);
                    //Maximale Koordinatenanzahl an die Zeilenanzahl übergeben
                    rowCount = chart1.Series[1].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[1].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[2, i].Value = chart1.Series[1].Points[i].XValue.ToString("g6");
                    dataGridView1[3, i].Value = chart1.Series[1].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 2)
            {
                dataGridView1.Columns[4].Name = chart1.Series[2].Name + ": X";
                dataGridView1.Columns[5].Name = chart1.Series[2].Name + ": Y";

                if (rowCount < chart1.Series[2].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[2].Points.Count - rowCount);
                    rowCount = chart1.Series[2].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[2].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[4, i].Value = chart1.Series[2].Points[i].XValue.ToString("g6");
                    dataGridView1[5, i].Value = chart1.Series[2].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 3)
            {
                dataGridView1.Columns[6].Name = chart1.Series[3].Name + ": X";
                dataGridView1.Columns[7].Name = chart1.Series[3].Name + ": Y";

                if (rowCount < chart1.Series[3].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[30].Points.Count - rowCount);
                    rowCount = chart1.Series[3].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[3].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[6, i].Value = chart1.Series[3].Points[i].XValue.ToString("g6");
                    dataGridView1[7, i].Value = chart1.Series[3].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 4)
            {
                dataGridView1.Columns[8].Name = chart1.Series[4].Name + ": X";
                dataGridView1.Columns[9].Name = chart1.Series[4].Name + ": Y";

                if (rowCount < chart1.Series[4].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[4].Points.Count - rowCount);
                    rowCount = chart1.Series[4].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[4].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[8, i].Value = chart1.Series[4].Points[i].XValue.ToString("g6");
                    dataGridView1[9, i].Value = chart1.Series[4].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 5)
            {
                dataGridView1.Columns[10].Name = chart1.Series[5].Name + ": X";
                dataGridView1.Columns[11].Name = chart1.Series[5].Name + ": Y";

                if (rowCount < chart1.Series[5].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[5].Points.Count - rowCount);
                    rowCount = chart1.Series[5].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[5].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[10, i].Value = chart1.Series[5].Points[i].XValue.ToString("g6");
                    dataGridView1[11, i].Value = chart1.Series[5].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 6)
            {
                dataGridView1.Columns[12].Name = chart1.Series[6].Name + ": X";
                dataGridView1.Columns[13].Name = chart1.Series[6].Name + ": Y";

                if (rowCount < chart1.Series[6].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[6].Points.Count - rowCount);
                    rowCount = chart1.Series[6].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[6].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[12, i].Value = chart1.Series[6].Points[i].XValue.ToString("g6");
                    dataGridView1[13, i].Value = chart1.Series[6].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 7)
            {
                dataGridView1.Columns[14].Name = chart1.Series[7].Name + ": X";
                dataGridView1.Columns[15].Name = chart1.Series[7].Name + ": Y";

                if (rowCount < chart1.Series[7].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[7].Points.Count - rowCount);
                    rowCount = chart1.Series[7].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[7].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[14, i].Value = chart1.Series[7].Points[i].XValue.ToString("g6");
                    dataGridView1[15, i].Value = chart1.Series[7].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 8)
            {
                dataGridView1.Columns[16].Name = chart1.Series[8].Name + ": X";
                dataGridView1.Columns[17].Name = chart1.Series[8].Name + ": Y";

                if (rowCount < chart1.Series[8].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[8].Points.Count - rowCount);
                    rowCount = chart1.Series[8].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[8].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[16, i].Value = chart1.Series[8].Points[i].XValue.ToString("g6");
                    dataGridView1[17, i].Value = chart1.Series[8].Points[i].YValues[0].ToString("g6");
                }
            }
            if (chart1.Series.Count > 9)
            {
                dataGridView1.Columns[18].Name = chart1.Series[9].Name + ": X";
                dataGridView1.Columns[19].Name = chart1.Series[9].Name + ": Y";

                if (rowCount < chart1.Series[9].Points.Count)
                {
                    dataGridView1.Rows.Add(chart1.Series[9].Points.Count - rowCount);
                    rowCount = chart1.Series[9].Points.Count;
                }
                for (int i = 0; i <= chart1.Series[9].Points.Count - 1; i++)
                {
                    dataGridView1.Rows[i].HeaderCell.Value = (i + 1).ToString();
                    dataGridView1[18, i].Value = chart1.Series[9].Points[i].XValue.ToString("g6");
                    dataGridView1[19, i].Value = chart1.Series[9].Points[i].YValues[0].ToString("g6");
                }
            }
        }

        #endregion

        #region Ändern von Werten im DataGridView

        private void dataGridView1_RowValidated(object sender, DataGridViewCellEventArgs e)
        {
            double temp = 0.0;

            //Kann nur geändert werden, wenn auch mit Inhalt gefüllt
            if (chart1.Series.Count>0 && e.ColumnIndex == 1 && e.RowIndex < chart1.Series[0].Points.Count)
            {
                //Geänderten Wert aus dem DataGridView auslesen
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                //An der geänderten Position den Wert in der ArrayList ändern
                chart1.Series[0].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 1 && e.ColumnIndex == 3 && e.RowIndex < chart1.Series[1].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[1].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 2 && e.ColumnIndex == 5 && e.RowIndex < chart1.Series[2].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[2].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 3 && e.ColumnIndex == 7 && e.RowIndex < chart1.Series[3].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[3].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 4 && e.ColumnIndex == 9 && e.RowIndex < chart1.Series[4].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[4].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 5 && e.ColumnIndex == 11 && e.RowIndex < chart1.Series[5].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[5].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 6 && e.ColumnIndex == 13 && e.RowIndex < chart1.Series[6].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[6].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 7 && e.ColumnIndex == 15 && e.RowIndex < chart1.Series[7].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[7].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 8 && e.ColumnIndex == 17 && e.RowIndex < chart1.Series[8].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[8].Points[e.RowIndex].YValues[0] = temp;
            }

            if (chart1.Series.Count > 9 && e.ColumnIndex == 19 && e.RowIndex < chart1.Series[9].Points.Count)
            {
                temp = Convert.ToDouble(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value);
                chart1.Series[9].Points[e.RowIndex].YValues[0] = temp;

            }
            //PictureBox neu zeichnen
            chart1.Invalidate();
        }

        #endregion

        #endregion

 
        #region Erstellen des Koordinatenkreuzes

        private void DrawKoord(Graphics g, bool print)
        {
            //string axisValue;
            //double gapValue;
            //float yCurrent;
            //float xCurrent;
            //float x; 
            //float y; 

            //GraphPBoxHeight = GraphPBox.Height;
            //GraphPBoxWidth = GraphPBox.Width;
            ////Koordinatenursprung festlegen
            //x = 49; //Abstand vom linken Rand 
            //y = GraphPBoxHeight + 50; //Abstand vom oberen Rand

            ////Einstellung zum Drucken
            ////Da sonst die Größe des Fensters verwendet wird, der Ausdruck ist also dann abhängig von der Größe
            //if (print == true)
            //{
            //    y = 275 + 50;
            //    GraphPBoxHeight = 275;
            //    GraphPBoxWidth = 450;
            //}

            ////Zeichenobjekte festlegen (Schriftart, Schriftfarbe)
            //Font divFont = new Font("Arial", 8);
            ////Einfarbiger Pinsel zum Füllen von Grafikformen, hier die Beschriftung der Achsen 
            //SolidBrush blackBrush = new SolidBrush(Color.Black);
            //Pen linePen = new Pen(Color.Black, 1); //Zeichenstift
            ////Objekt zur Bestimmung der Textbreite
            //SizeF stringSize;

            ////Y-Achse-------------------------------------------------------------------------------------------
            ////Min-Wert eintragen (Koordinatenursprung)
            //stringSize = g.MeasureString(yMin.ToString("g3"), divFont); //Länge des Strings bestimmen
            //g.DrawString(yMin.ToString("g3"), divFont, blackBrush, x - stringSize.Width - 3, GraphPBoxHeight + 43);
            //g.DrawLine(linePen, x, GraphPBoxHeight + 50, x - 2, GraphPBoxHeight + 50); //Erste Gaplinie zeichnen

            ////Zeichnen der Gapstriche und Beschriftung der Achse zwischen dem minimalen und maximalen Wert
            //for (gapValue = yMin + yGap; gapValue < yMax; gapValue += yGap)
            //{
            //    gapValue = Math.Round(gapValue, 10);  //Runden wegen Rechengenauigkeit
            //    yCurrent = (float)(y - (axisYFactor * (gapValue - yMin))); //Berechnung der Position, an der gezeichnet werden soll (-, weil noch von oben gezeichnet wird)

            //    axisValue = gapValue.ToString("g3"); //Umwandlung des aktuellen Gap in String
            //    stringSize = g.MeasureString(axisValue, divFont); //Länge des Strings bestimmen
            //    g.DrawString(axisValue, divFont, blackBrush, x - stringSize.Width - 3, yCurrent - 7); //Beschriftung der Achse zeichnen und Position übergeben
            //    g.DrawLine(linePen, x, yCurrent, x - 2, yCurrent); //Gaplinie zeichen (2 Pixel lang)
            //}

            ////Max-Wert eintragen (Ende der Y-Linie)
            //stringSize = g.MeasureString(yMax.ToString("g3"), divFont); //Länge des Strings bestimmen
            //g.DrawString(yMax.ToString("g3"), divFont, blackBrush, x - stringSize.Width - 3, 43f);
            //g.DrawLine(linePen, x, 50f, x - 2, 50f); //Letzte Gaplinie zeichnen
            ////--------------------------------------------------------------------------------------------------

            ////X-Achse-------------------------------------------------------------------------------------------
            ////Min-Wert eintragen (Koordinatenursprung)
            //stringSize = g.MeasureString(xMin.ToString("g3"), divFont);
            //g.DrawString(xMin.ToString("g3"), divFont, blackBrush, x - stringSize.Width / 2, y + 3);
            //g.DrawLine(linePen, x, y, x, y + 2); //Erste Gaplinie zeichnen

            ////Zeichnen der Gapstriche und Beschriftung der Achse zwischen dem minimalen und maximalen Wert
            //for (gapValue = xMin + xGap; gapValue < xMax; gapValue += xGap)
            //{
            //    gapValue = Math.Round(gapValue, 10);  //Runden wegen Rechengenauigkeit
            //    xCurrent = (float)(x + (axisXFactor * (gapValue - xMin))); //Berechnung der Position, an der gezeichnet werden soll 

            //    axisValue = gapValue.ToString("g3"); //Umwandlung des aktuellen Gap in String
            //    stringSize = g.MeasureString(axisValue, divFont); //Länge des Strings bestimmen
            //    g.DrawString(axisValue, divFont, blackBrush, xCurrent - stringSize.Width / 2, y + 3); //Beschriftung der Achse zeichnen und Position übergeben
            //    g.DrawLine(linePen, xCurrent, y, xCurrent, y + 2); //Gaplinie zeichen (2 Pixel lang)
            //}

            ////Max-Wert eintragen (Ende der X-Linie)
            //stringSize = g.MeasureString(xMax.ToString("g3"), divFont); //Länge des Strings bestimmen
            //g.DrawString(xMax.ToString("g3"), divFont, blackBrush, x + GraphPBoxWidth - stringSize.Width / 2, y + 3);
            //g.DrawLine(linePen, x + GraphPBoxWidth, y, x + GraphPBoxWidth, y + 2); //Letzte Gaplinie zeichnen
            ////--------------------------------------------------------------------------------------------------

            ////Koordinatenkreuz zeichnen
            //g.DrawLine(linePen, x, 50, x, y);
            //g.DrawLine(linePen, x, y, GraphPBoxWidth + x, y);

            ////Zeichenressourcen freigeben
            //linePen.Dispose();
            //divFont.Dispose();
            //blackBrush.Dispose();
        }

        #endregion

        #region Über- und Unterschrift

 
        #endregion  

        #region Koordinatenraster

        private void DrawGrid(Graphics g, bool print)
        {
            //Pen gridLine = new Pen(Color.LightGray, 1); //Zeichenstift festlegen
            //gridLine.DashStyle = DashStyle.Dash; //Gestrichelte Linie festlegen

            //GraphPBoxHeight = GraphPBox.Height;
            //GraphPBoxWidth = GraphPBox.Width;

            ////Drucken: feste Werte
            //if (print == true)
            //{
            //    GraphPBoxHeight = 275;
            //    GraphPBoxWidth = 450;
            //}

            //if (yGrid == true) //Y-Grid zeichnen
            //{
            //    float yCurrent;
            //    double gapValue;

            //    //Vom ersten Gap bis zum letzten Gab
            //    for (gapValue = yMin + yGap; gapValue < yMax; gapValue += yGap)
            //    {
            //        gapValue = Math.Round(gapValue, 10);  //Runden wegen Rechengenauigkeit
            //        yCurrent = (float)(axisYFactor * (gapValue - yMin)); //Berechnung der Position, an der gezeichnet werden soll

            //        g.DrawLine(gridLine, 0, yCurrent, GraphPBoxWidth, yCurrent); //Gridlinie zeichnen
            //    }
            //    g.DrawLine(gridLine, 0, GraphPBoxHeight, GraphPBoxWidth, GraphPBoxHeight); //Gridlinie beim maximalen Wert zeichnen
            //}

            //if (xGrid == true) //X-Grid
            //{
            //    float xCurrent;
            //    double gapValue;

            //    //Vom ersten Gap bis zum letzten Gab
            //    for (gapValue = xMin + xGap; gapValue < xMax; gapValue += xGap)
            //    {
            //        gapValue = Math.Round(gapValue, 10);  //Runden wegen Rechengenauigkeit
            //        xCurrent = (float)(axisXFactor * (gapValue - xMin) - 1); //Berechnung der Position, an der gezeichnet werden soll

            //        g.DrawLine(gridLine, xCurrent, 0, xCurrent, GraphPBoxHeight); //Gridlinie zeichnen
            //    }
            //    g.DrawLine(gridLine, GraphPBoxWidth - 1, 0, GraphPBoxWidth - 1, GraphPBoxHeight); //Gridlinie beim maximalen Wert zeichnen
            //}

            ////Zeichenressourcen freigeben
            //gridLine.Dispose();
        }

        #endregion

 
        #region Automatische Größenanpassung

        private void AxisPBox_Resize(object sender, EventArgs e)
        {
            ////Funktion wird beim Ändern der Größe aufgerufen.
            ////Innere PictureBox an äußere gekoppelt
            //GraphPBox.Height = AxisPBox.Size.Height - 100;
            //GraphPBox.Width = AxisPBox.Size.Width - 75;
            ////Beide PictureBoxen neu zeichnen (Inhalt)
            //GraphPBox.Invalidate();
            //AxisPBox.Invalidate();
        }

        #endregion

        #region Buttonleiste

        #region Datei speichern

        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                saveChart(saveFileDialog1.FileName); //Speicherfunktion
            }
        }

        #endregion

        #region Datei laden

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            if (chart1.Series.Count > 0)
                if (MessageBox.Show(this, allCurvesDeleted, "", MessageBoxButtons.OKCancel) == DialogResult.OK)
                    clearAll(); //Gesamten Inhalt löschen
            if (chart1.Series.Count == 0)
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {

                    chart1.Visible = true;
                    loadChart(openFileDialog1.FileName); //Ladefunktion
                }
            DrawLegend();

            setEData();
        }

        #endregion

        #region Drucken

        private void buttonPrint_Click(object sender, EventArgs e)
        {
            try
            {
                chart1.Legends[0].Enabled = true;
                Color help = chart1.ChartAreas[0].AxisX.MinorGrid.LineColor;
                Color helpmaj = chart1.ChartAreas[0].AxisX.MajorGrid.LineColor;
                chart1.ChartAreas[0].AxisX.MinorGrid.LineColor = Color.LightBlue;
                chart1.ChartAreas[0].AxisY.MinorGrid.LineColor = Color.LightBlue;
                chart1.ChartAreas[0].AxisX.MajorGrid.LineColor = Color.Black;
                chart1.ChartAreas[0].AxisY.MajorGrid.LineColor = Color.Black;
                chart1.Printing.PageSetup();
                chart1.Printing.Print(true);
                chart1.ChartAreas[0].AxisX.MinorGrid.LineColor = help;
                chart1.ChartAreas[0].AxisY.MinorGrid.LineColor = help;
                chart1.ChartAreas[0].AxisX.MajorGrid.LineColor = helpmaj;
                chart1.ChartAreas[0].AxisY.MajorGrid.LineColor = helpmaj;
                chart1.Legends[0].Enabled = false;
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Chart Control for .NET Framework", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }

        #endregion

        #region Über- und Unterschrift ändern

        private void init_Titles()
        {
            // Texte aus frmtitle in die Chart1 schreiben
            chart1.Titles.Clear();
            chart1.Titles.Add("Top Titel");
            chart1.Titles.Add("Bottom Titel");
            chart1.Titles.Add("Left Titel");
            chart1.Titles.Add("Right Titel");

            chart1.Titles[0].Docking = Docking.Top;
            chart1.Titles[1].Docking = Docking.Bottom;
            chart1.Titles[2].Docking = Docking.Left;
            chart1.Titles[3].Docking = Docking.Right;

            chart1.Titles[0].Text = frmtitle.TopTitletextBox.Text;
            chart1.Titles[1].Text = frmtitle.BottomTitletextBox.Text;
            chart1.Titles[2].Text = frmtitle.tBTitleLeft.Text;
            chart1.Titles[3].Text = frmtitle.tBTitleRight.Text;

            for (int i = 0; i < 4; i++)
                if (chart1.Titles[i].Text.Length > 0)
                    chart1.Titles[i].Visible = true;
                else chart1.Titles[i].Visible = false;

        }
        
        private void buttonTitle_Click(object sender, EventArgs e)
        {
            if (frmtitle.ShowDialog() == DialogResult.OK)
            {
                init_Titles();
            }

        }

        #endregion

        #region Legende


        public void toggleLegend()
        {
            checkButtonLegend_Click(null,null);
        }


        //Blendet die Legende aus und ein
        private void checkButtonLegend_Click(object sender, EventArgs e)
        {
            if (splitContainer1.Panel2Collapsed == true)
            {
                splitContainer1.Panel2Collapsed = false;
            }
            else 
            {
                splitContainer1.Panel2Collapsed = true;
            }
        }

        public void DrawLegend()
        {
            // Zeichnet die Legende rechts neben chart1 mit Panels und Labels neu

            if (chart1.Series.Count > 0)
            {
                 chart1.Series[0].LegendText=CurveNames[0] ;
                ColorPen0 = chart1.Series[0].Color;
                ColorCurve0.BackColor = ColorPen0;
                cutCurve0.ForeColor = ColorPen0;
                NameCurve0.Visible = true;
                ColorCurve0.Visible = true;
                cutCurve0.Visible = true;
            }
            else
            {
                NameCurve0.Visible = false;
                ColorCurve0.Visible = false;
                cutCurve0.Visible = false;
            }
            if (chart1.Series.Count > 1)
            {
                chart1.Series[1].LegendText=CurveNames[1];
                ColorPen1 = chart1.Series[1].Color;
                ColorCurve1.BackColor = ColorPen1;
                cutCurve1.ForeColor = ColorPen1;
                NameCurve1.Visible = true;
                ColorCurve1.Visible = true;
                cutCurve1.Visible = true;
            }
            else
            {
                NameCurve1.Visible = false;
                ColorCurve1.Visible = false;
                cutCurve1.Visible = false;
            }
            if (chart1.Series.Count > 2)
            {
                chart1.Series[2].LegendText= CurveNames[2] ;
                ColorPen2 = chart1.Series[2].Color;
                ColorCurve2.BackColor = ColorPen2;
                cutCurve2.ForeColor = ColorPen2;
                NameCurve2.Visible = true;
                ColorCurve2.Visible = true;
                cutCurve2.Visible = true;
            }
            else
            {
                NameCurve2.Visible = false;
                ColorCurve2.Visible = false;
                cutCurve2.Visible = false;
            }
            if (chart1.Series.Count > 3)
            {
                  chart1.Series[3].LegendText=CurveNames[3];
                ColorPen3 = chart1.Series[3].Color;
                ColorCurve3.BackColor = ColorPen3;
                cutCurve3.ForeColor = ColorPen3;
                NameCurve3.Visible = true;
                ColorCurve3.Visible = true;
                cutCurve3.Visible = true;
            }
            else
            {
                NameCurve3.Visible = false;
                ColorCurve3.Visible = false;
                cutCurve3.Visible = false;
            }
            if (chart1.Series.Count > 4)
            {
                 chart1.Series[4].LegendText=CurveNames[4] ;
                ColorPen4 = chart1.Series[4].Color;
                ColorCurve4.BackColor = ColorPen4;
                cutCurve4.ForeColor = ColorPen4;
                NameCurve4.Visible = true;
                ColorCurve4.Visible = true;
                cutCurve4.Visible = true;
            }
            else
            {
                NameCurve4.Visible = false;
                ColorCurve4.Visible = false;
                cutCurve4.Visible = false;
            }
            if (chart1.Series.Count > 5)
            {
                chart1.Series[5].LegendText=CurveNames[5] ;
                ColorPen5 = chart1.Series[5].Color;
                ColorCurve5.BackColor = ColorPen5;
                cutCurve5.ForeColor = ColorPen5;
                NameCurve5.Visible = true;
                ColorCurve5.Visible = true;
                cutCurve5.Visible = true;
            }
            else
            {
                NameCurve5.Visible = false;
                ColorCurve5.Visible = false;
                cutCurve5.Visible = false;
            }
            if (chart1.Series.Count > 6)
            {
                  chart1.Series[6].LegendText=CurveNames[6];
                ColorPen6 = chart1.Series[6].Color;
                ColorCurve6.BackColor = ColorPen6;
                cutCurve6.ForeColor = ColorPen6;
                NameCurve6.Visible = true;
                ColorCurve6.Visible = true;
                cutCurve6.Visible = true;
            }
            else
            {
                NameCurve6.Visible = false;
                ColorCurve6.Visible = false;
                cutCurve6.Visible = false;
            }
            if (chart1.Series.Count > 7)
            {
                 chart1.Series[7].LegendText=CurveNames[7];
                ColorPen7 = chart1.Series[7].Color;
                ColorCurve7.BackColor = ColorPen7;
                cutCurve7.ForeColor = ColorPen7;
                NameCurve7.Visible = true;
                ColorCurve7.Visible = true;
                cutCurve7.Visible = true;
            }
            else
            {
                NameCurve7.Visible = false;
                ColorCurve7.Visible = false;
                cutCurve7.Visible = false;
            }
            if (chart1.Series.Count > 8)
            {
                 chart1.Series[8].LegendText=CurveNames[8] ;
                ColorPen8 = chart1.Series[8].Color;
                ColorCurve8.BackColor = ColorPen8;
                cutCurve8.ForeColor = ColorPen8;
                NameCurve8.Visible = true;
                ColorCurve8.Visible = true;
                cutCurve8.Visible = true;
            }
            else
            {
                NameCurve8.Visible = false;
                ColorCurve8.Visible = false;
                cutCurve8.Visible = false;
            }
            if (chart1.Series.Count > 9)
            {
                chart1.Series[9].LegendText=CurveNames[9];
                ColorPen9 = chart1.Series[9].Color;
                ColorCurve9.BackColor = ColorPen9;
                cutCurve9.ForeColor = ColorPen9;
                NameCurve9.Visible = true;
                ColorCurve9.Visible = true;
                cutCurve9.Visible = true;
            }
            else
            {
                NameCurve9.Visible = false;
                ColorCurve9.Visible = false;
                cutCurve9.Visible = false;
            }
            updateNames();
        }

        #endregion

        #region Koordinatenraster

        //X-Grid anzeigen  
        // Neu: Diese Taste Schaltet major Grid x+y ein / aus
        private void checkButtonXGrid_Click(object sender, EventArgs e)
        {
            xGrid++;
            if (xGrid == 2) xGrid = 0;

            if (xGrid == 0)
                foreach (ChartArea chartarea in chart1.ChartAreas)
                {
                    chartarea.AxisY.MajorGrid.Enabled = false;
                    chartarea.AxisX.MajorGrid.Enabled = false;
                    chartarea.AxisY.MinorGrid.Enabled = false;
                    chartarea.AxisX.MinorGrid.Enabled = false;
                    chartarea.AxisY2.MinorGrid.Enabled = false;
                    chartarea.AxisY2.MajorGrid.Enabled = false;
                    yGrid = 0;
                }
            if (xGrid == 1)
                foreach (ChartArea chartarea in chart1.ChartAreas)
                {
                    chartarea.AxisY.MajorGrid.Enabled = true;
                    chartarea.AxisY2.MajorGrid.Enabled = true;
                    chartarea.AxisX.MajorGrid.Enabled = true;
                }
        }
        //Y-Grid anzeigen 
        // Neu. Schaltet Minor- Grid x+y ein /aus
        private void checkButtonYGrid_Click(object sender, EventArgs e)
        {
            yGrid++;
            if (yGrid == 2) yGrid = 0;

            if (yGrid == 0)
                foreach (ChartArea chartarea in chart1.ChartAreas)
                {
                    chartarea.AxisY.MinorGrid.Enabled = false;
                    chartarea.AxisX.MinorGrid.Enabled = false;
                    chartarea.AxisY2.MinorGrid.Enabled = false;
                    //chartarea.AxisY2.MajorGrid.Enabled = false;
                }
            if (yGrid == 1)
                foreach (ChartArea chartarea in chart1.ChartAreas)
                {
                    chartarea.AxisY.MinorGrid.Enabled = true;
                    chartarea.AxisY.MajorGrid.Enabled = true;
                    chartarea.AxisX.MinorGrid.Enabled = true;
                    chartarea.AxisX.MajorGrid.Enabled = true;
                    chartarea.AxisY2.MinorGrid.Enabled = true;
                    chartarea.AxisY2.MajorGrid.Enabled = true;
                    xGrid = 1;
                }
        }

        #endregion

        #region Dateneditor

        //Blendet das DataGridView ein und aus
        private void checkButtonEditor_Click(object sender, EventArgs e)
        {
            if (EditorPanel.Visible == false)
            {
                EditorPanel.Visible = true;
                setEData();
            }
            else 
            {
                EditorPanel.Visible = false;
            }
        }
        #endregion

        #region Zoom

        private void checkButtonZoom_Click(object sender, EventArgs e)
        {
           
            if (!zoom)
            {
                zoom = true;
                foreach (ChartArea chartArea in chart1.ChartAreas)
                {
                    // Grid für Cursor in .CursorX 
                    chartArea.CursorX.IsUserEnabled = true;
                    chartArea.CursorX.IsUserSelectionEnabled = true;
                    chartArea.AxisX.ScaleView.Zoomable = true;
                    chartArea.AxisX.ScrollBar.IsPositionedInside = true;
                    chartArea.AxisX.ScrollBar.Enabled = true;
                   
                    chartArea.AxisY.ScaleView.Zoomable = true;

                    //chartArea.AxisX.ScrollBar.Size = 0.1;  // künstlicher Fehler zur Laufzeit zum Debuggen
                    chartArea.AxisY.ScrollBar.IsPositionedInside = true;
                    chartArea.AxisY.ScrollBar.Enabled = true;
                    chartArea.AxisY2.ScaleView.Zoomable = true;
                    chartArea.AxisY2.ScrollBar.IsPositionedInside = true;
                    chartArea.AxisY2.ScrollBar.Enabled = true;

                    chartArea.CursorX.SelectionColor = Color.LightSlateGray;
                    chartArea.CursorY.IsUserEnabled = true;
                    chartArea.CursorY.IsUserSelectionEnabled = true;
                    chartArea.CursorY.SelectionColor = Color.LightSlateGray;
               }
            }
            else
            {
                zoom = false;
                foreach (ChartArea chartArea in chart1.ChartAreas)
                {
                    chartArea.AxisX.ScaleView.Zoomable = false;
                    chartArea.AxisX.ScrollBar.Enabled = false;
                    chartArea.AxisY.ScaleView.Zoomable = false;
                    chartArea.AxisY.ScrollBar.Enabled = false;
                    chartArea.AxisY2.ScaleView.Zoomable = false;
                    chartArea.AxisY2.ScrollBar.Enabled = false;
                    chartArea.CursorX.IsUserSelectionEnabled = false;
                    chartArea.CursorY.IsUserSelectionEnabled = false;
                    chartArea.CursorX.IsUserEnabled = false;
                    chartArea.CursorY.IsUserEnabled = false;
                    chartArea.AxisX.ScaleView.ZoomReset();
                    chartArea.AxisY.ScaleView.ZoomReset();
                    chartArea.AxisY2.ScaleView.ZoomReset();
                }
            }
            //Bpanel.BackColor = Color.HotPink;

        }

        #endregion

#endregion

        #region Skalierung

        #region Manuell

        private void buttonScaling_Click(object sender, EventArgs e)
        {


            double temp = 0;

            //Skalierungswerte an das Zusatzfenster übergeben 
            frmscaling.XGaptextBox.Text = chart1.ChartAreas[0].AxisX.Interval.ToString();
            frmscaling.XminGaptextBox.Text = chart1.ChartAreas[0].AxisX.MinorGrid.Interval.ToString();
            frmscaling.tBCursorX.Text = chart1.ChartAreas[0].CursorX.Interval.ToString();
            frmscaling.XMaxtextBox.Text = chart1.ChartAreas[0].AxisX.Maximum.ToString();
            frmscaling.XMintextBox.Text = chart1.ChartAreas[0].AxisX.Minimum.ToString();

            frmscaling.YGaptextBox.Text = chart1.ChartAreas[0].AxisY.Interval.ToString();
            frmscaling.YMinGaptextBox.Text = chart1.ChartAreas[0].AxisY.MinorGrid.Interval.ToString();
            frmscaling.tBCursorY.Text = chart1.ChartAreas[0].CursorY.Interval.ToString();
            frmscaling.YMaxtextBox.Text = chart1.ChartAreas[0].AxisY.Maximum.ToString();
            frmscaling.YMintextBox.Text = chart1.ChartAreas[0].AxisY.Minimum.ToString();

            frmscaling.Y2GaptextBox.Text = chart1.ChartAreas[0].AxisY2.Interval.ToString();
            frmscaling.Y2MinGaptextBox.Text = chart1.ChartAreas[0].AxisY2.MinorGrid.Interval.ToString();
            frmscaling.Y2MaxtextBox.Text = chart1.ChartAreas[0].AxisY2.Maximum.ToString();
            frmscaling.Y2MintextBox.Text = chart1.ChartAreas[0].AxisY2.Minimum.ToString();

            frmscaling.cBLog.Checked = chart1.ChartAreas[0].AxisX.IsLogarithmic;
            if (chart1.ChartAreas[0].AxisY2.Enabled == AxisEnabled.True)
                frmscaling.cBY2.Checked = true;
            else frmscaling.cBY2.Checked = false;
            if (frmscaling.ShowDialog() == DialogResult.OK)
            {
                //Neue Skalierungswerte übergeben 
                //x
                ConvertToDouble(frmscaling.XGaptextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisX.Interval = temp;
                chart1.ChartAreas[0].AxisX.MajorGrid.Interval = temp;  // ab 7.7. drin
                ConvertToDouble(frmscaling.XminGaptextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisX.MinorGrid.Interval = temp;
                ConvertToDouble(frmscaling.XMaxtextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisX.Maximum = temp;
                ConvertToDouble(frmscaling.XMintextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisX.Minimum = temp;
                ConvertToDouble(frmscaling.tBCursorX.Text, ref temp);
                chart1.ChartAreas[0].CursorX.Interval = temp;
                //y
                ConvertToDouble(frmscaling.YGaptextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY.Interval = temp;
                chart1.ChartAreas[0].AxisY.MajorGrid.Interval = temp;  // ab 7.7. drin
                ConvertToDouble(frmscaling.YMinGaptextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY.MinorGrid.Interval = temp;
                ConvertToDouble(frmscaling.YMaxtextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY.Maximum = temp;
                ConvertToDouble(frmscaling.YMintextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY.Minimum = temp;
                ConvertToDouble(frmscaling.tBCursorY.Text, ref temp);
                chart1.ChartAreas[0].CursorY.Interval = temp;
                // Y2
                ConvertToDouble(frmscaling.Y2GaptextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY2.Interval = temp;
                chart1.ChartAreas[0].AxisY2.MajorGrid.Interval = temp;  // ab 7.7. drin
                ConvertToDouble(frmscaling.Y2MinGaptextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY2.MinorGrid.Interval = temp;
                ConvertToDouble(frmscaling.Y2MaxtextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY2.Maximum = temp;
                ConvertToDouble(frmscaling.Y2MintextBox.Text, ref temp);
                chart1.ChartAreas[0].AxisY2.Minimum = temp;

                // log nur wenn alle x-Achsenwerte Positiv und >0
                if (chart1.ChartAreas[0].AxisX.Maximum > 0)
                    if (chart1.ChartAreas[0].AxisX.Minimum > 0)
                        if (frmscaling.cBLog.Checked)
                            chart1.ChartAreas[0].AxisX.IsLogarithmic = frmscaling.cBLog.Checked;
                if (chart1.ChartAreas[0].AxisX.IsLogarithmic != frmscaling.cBLog.Checked)
                    MessageBox.Show(loggehtnicht);
                if (frmscaling.cBY2.Checked)
                    chart1.ChartAreas[0].AxisY2.Enabled = AxisEnabled.True;
                else chart1.ChartAreas[0].AxisY2.Enabled = AxisEnabled.False;

                // neu zeichnen
                chart1.Invalidate();
                chart1.ChartAreas.Invalidate();

            }
        }

        #endregion

        #region Automatisch

        //Ruft die Funktion autoScaling() auf
        private void buttonAutoScale_Click(object sender, EventArgs e)
        {
            autoScaling();
        }

        #region Automatische Skalierung

        //AutoScale von Prof. Dr. Bayerlein
        /// <summary>
        /// Ruft die automatische Skalierung auf.
        /// </summary>
        public void autoScaling()
        {

            int zehnerpot, add;
            double maxX, minX, maxY, minY, maxabswert;

            List<Series>[] list_serie = null;

            if (chart1.ChartAreas.Count > 0)
            {
                list_serie = new List<Series>[chart1.ChartAreas.Count];

                for (int i = 0; i < list_serie.Length; i++)
                {
                    list_serie[i] = new List<Series>();
                }
            }

            for (int i = 0; i < chart1.ChartAreas.Count; i++)
            {
                foreach (Series s in chart1.Series)
                {
                    if (s.ChartArea == chart1.ChartAreas[i].Name)
                        list_serie[i].Add(s);
                }

                if (list_serie[i].Count > 0)
                {
                    maxX = list_serie[i][0].Points.FindMaxByValue("X").XValue;
                    minX = list_serie[i][0].Points.FindMinByValue("X").XValue;
                    maxY = list_serie[i][0].Points.FindMaxByValue("Y").YValues[0];
                    minY = list_serie[i][0].Points.FindMinByValue("Y").YValues[0];
                    //double abc = 123 / 0.0;
                    foreach (Series serie in list_serie[i])
                    {
                        if (serie.YAxisType != System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary)
                        {
                            if (maxX < serie.Points.FindMaxByValue("X").XValue)
                                maxX = serie.Points.FindMaxByValue("X").XValue;
                            if (minX > serie.Points.FindMinByValue("X").XValue)
                                minX = serie.Points.FindMinByValue("X").XValue;
                            if (maxY < serie.Points.FindMaxByValue("Y").YValues[0])
                                maxY = serie.Points.FindMaxByValue("Y").YValues[0];
                            if (minY > serie.Points.FindMinByValue("Y").YValues[0])
                                minY = serie.Points.FindMinByValue("Y").YValues[0];
                        }
                    }

                    //Prof. Dr. Bayerlein
                    //Entnommen aus Windf
                    /* ymax and ymin rounded between 2...19.99 to next 1
                                                    0.2 ... 1.999 to next 0.1
                                                    20 .. 199.9 to next 10
                                              and so on */

                    ////Old Version bis 19.4.2015 Ve 7.15
                    //if (Math.Abs(maxY) > Math.Abs(minY)) maxabswert = Math.Abs(maxY);
                    //else maxabswert = Math.Abs(minY);
                    //if (maxabswert < 2) add = -1; else add = 0;
                    //zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                    //yGap = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                    //if (maxY > 0) add = 1; else add = 0;
                    //yMax = yGap * (int)(maxY / yGap + add);
                    //if (minY >= 0) add = 0; else add = -1;
                    //yMin = yGap * (int)(minY / yGap + add);
                    //// Ende OLD Version
                    maxabswert = Math.Abs(maxY - minY);
                    if (maxabswert > 1e-9)
                    {
                        if (maxabswert < 2) add = -1; else add = 0;
                        zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                        yGap = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                        if (maxY > 0) add = 1; else add = 0;
                        yMax = yGap * (int)(maxY / yGap + add);
                        if (minY >= 0) add = 0; else add = -1;
                        yMin = yGap * (int)(minY / yGap + add);
                    }
                    else
                    {   // case horizontal curve
                        yMax = maxY + 1e-8; // Case if vertical curve
                        yMin = minY - 1e-8;
                        yGap = 2e-9;
                     }
                    /* xmax and xmin rounded between 2...19.99 to next 1
                                                    0.2 ... 1.999 to next 0.1
                                                    20 .. 199.9 to next 10
                                              and so on */
                    if (!xlogdesired)  //chart1.ChartAreas[0].AxisX.IsLogarithmic
                    {
                        // case lin- axis 
                        //if (Math.Abs(maxX) > Math.Abs(minX)) maxabswert = Math.Abs(maxX);// old
                        maxabswert = Math.Abs(maxX-minX);
                        if (maxabswert > 1e-9)
                        {
                            if (maxabswert <= 2) add = -1; else add = 0;
                            zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                            xGap = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                            if (maxX > 0) add = 1; else add = 0;
                            xMax = xGap * (int)(maxX / xGap + add);
                            if (minX >= 0) add = 0; else add = -1;
                            xMin = xGap * (int)(minX / xGap + add);

                           
                        }
                        else
                        {
                            xMax = maxX + 1e-8; // Case if vertical curve
                            xMin = minX - 1e-8;
                            xGap = 2e-9;
                        }

                        chart1.ChartAreas[0].AxisX.Minimum = xMin;
                        chart1.ChartAreas[0].AxisX.Maximum = xMax;                           
                        chart1.ChartAreas[0].AxisX.Interval = xGap;
                        chart1.ChartAreas[0].AxisX.MajorGrid.Interval = xGap;  // ab 7.7. drin
                        chart1.ChartAreas[0].AxisX.MinorGrid.Interval = xGap / 5.0;
                        frmscaling.XGaptextBox.Text = chart1.ChartAreas[0].AxisX.Interval.ToString();
                        frmscaling.XminGaptextBox.Text = chart1.ChartAreas[0].AxisX.MinorGrid.Interval.ToString();
                        frmscaling.tBCursorX.Text = chart1.ChartAreas[0].CursorX.Interval.ToString();
                        frmscaling.XMaxtextBox.Text = chart1.ChartAreas[0].AxisX.Maximum.ToString();
                        frmscaling.XMintextBox.Text = chart1.ChartAreas[0].AxisX.Minimum.ToString();
                        chart1.ChartAreas[0].AxisX.IsLogarithmic = false;
                    }
                    else
                    {  // case Log- x - Axis
                        if (minX > 0)  // only possible with positive x-values
                        {
                            double lmaxX, lminX;
                            lmaxX = Math.Log10(maxX * 0.99999999999);
                            lminX = Math.Log10(minX * 1.00000000001);
                            if (Math.Abs(lmaxX) > Math.Abs(lminX)) maxabswert = Math.Abs(lmaxX);
                            else maxabswert = Math.Abs(lminX);
                            if (maxabswert <= 2) add = -1; else add = 0;
                            zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                            xGap = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                            if (lmaxX > 0) add = 1; else add = 0;
                            xMax = xGap * (int)(lmaxX / xGap + add);
                            if (lminX >= 0) add = 0; else add = -1;
                            xMin = xGap * (int)(lminX / xGap + add);

                            chart1.ChartAreas[0].AxisX.Minimum = Math.Pow(10, xMin);
                            if (xMin == xMax)
                                chart1.ChartAreas[0].AxisX.Maximum = Math.Pow(10, xMin + 0.1);// Case if horizontal curve
                            else
                                chart1.ChartAreas[0].AxisX.Maximum = Math.Pow(10, xMax);
                            chart1.ChartAreas[0].AxisX.Interval = 1;
                            chart1.ChartAreas[0].AxisX.MajorGrid.Interval = 1;  // ab 7.7. drin
                            chart1.ChartAreas[0].AxisX.MinorGrid.Interval = 1;
                            frmscaling.XGaptextBox.Text = chart1.ChartAreas[0].AxisX.Interval.ToString();
                            frmscaling.XminGaptextBox.Text = chart1.ChartAreas[0].AxisX.MinorGrid.Interval.ToString();
                            frmscaling.tBCursorX.Text = chart1.ChartAreas[0].CursorX.Interval.ToString();
                            frmscaling.XMaxtextBox.Text = chart1.ChartAreas[0].AxisX.Maximum.ToString();
                            frmscaling.XMintextBox.Text = chart1.ChartAreas[0].AxisX.Minimum.ToString();
                            chart1.ChartAreas[0].AxisX.IsLogarithmic = true;
                            XLOG = xlogdesired;

                        }
                    }
                    chart1.ChartAreas[0].AxisY.Minimum = yMin;
                    chart1.ChartAreas[0].AxisY.Maximum = yMax;
                    chart1.ChartAreas[0].AxisY.Interval = yGap;
                    chart1.ChartAreas[0].AxisY.MajorGrid.Interval = yGap;  // ab 7.7. drin
                    chart1.ChartAreas[0].AxisY.MinorGrid.Interval = yGap / 5.0;
                    chart1.ChartAreas[0].CursorX.Interval = xGap / 10.0;
                    chart1.ChartAreas[0].CursorY.Interval = yGap / 10.0;
                    // nix for Y2
                    frmscaling.YGaptextBox.Text = chart1.ChartAreas[0].AxisY.Interval.ToString();
                    frmscaling.YMinGaptextBox.Text = chart1.ChartAreas[0].AxisY.MinorGrid.Interval.ToString();
                    frmscaling.tBCursorY.Text = chart1.ChartAreas[0].CursorY.Interval.ToString();
                    frmscaling.YMaxtextBox.Text = chart1.ChartAreas[0].AxisY.Maximum.ToString();
                    frmscaling.YMintextBox.Text = chart1.ChartAreas[0].AxisY.Minimum.ToString();

                    chart1.Invalidate();
                }
            }
        }

        public void autoscaleY2()
        {

            int zehnerpot, add;
            double maxX, minX, maxY, minY, maxabswert;
            double xMax, xMin, xGap, yGap;

            List<Series>[] list_serie = null;

            if (chart1.ChartAreas.Count > 0)
            {
                list_serie = new List<Series>[chart1.ChartAreas.Count];

                for (int i = 0; i < list_serie.Length; i++)
                {
                    list_serie[i] = new List<Series>();
                }
            }

            for (int i = 0; i < chart1.ChartAreas.Count; i++)
            {
                foreach (Series s in chart1.Series)
                {
                    if (s.ChartArea == chart1.ChartAreas[i].Name)
                        list_serie[i].Add(s);
                }

                if (list_serie[i].Count > 0)
                {
                    maxX = list_serie[i][0].Points.FindMaxByValue("X").XValue;
                    minX = list_serie[i][0].Points.FindMinByValue("X").XValue;
                    maxY = list_serie[i][0].Points.FindMaxByValue("Y").YValues[0];
                    minY = list_serie[i][0].Points.FindMinByValue("Y").YValues[0];

                    foreach (Series serie in list_serie[i])
                    {
                        if (serie.YAxisType == System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary)
                        {
                            if (maxX < serie.Points.FindMaxByValue().XValue)
                                maxX = serie.Points.FindMaxByValue().XValue;
                            if (minX > serie.Points.FindMinByValue().XValue)
                                minX = serie.Points.FindMinByValue().XValue;
                            if (maxY < serie.Points.FindMaxByValue().YValues[0])
                                maxY = serie.Points.FindMaxByValue().YValues[0];
                            if (minY > serie.Points.FindMinByValue().YValues[0])
                                minY = serie.Points.FindMinByValue().YValues[0];
                        }
                    }

                    //Prof. Dr. Bayerlein
                    //Entnommen aus Windf
                    /* ymax and ymin rounded between 2...19.99 to next 1
                                                    0.2 ... 1.999 to next 0.1
                                                    20 .. 199.9 to next 10
                                              and so on */
                    if (Math.Abs(maxY) > Math.Abs(minY)) maxabswert = Math.Abs(maxY);
                    else maxabswert = Math.Abs(minY);
                    if (maxabswert < 2) add = -1; else add = 0;
                    zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                    yGap = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                    if (maxY > 0) add = 1; else add = 0;
                    y2Max = yGap * (int)(maxY / yGap + add);
                    if (minY >= 0) add = 0; else add = -1;
                    y2Min = yGap * (int)(minY / yGap + add);
                    /* xmax and xmin rounded between 2...19.99 to next 1
                                                    0.2 ... 1.999 to next 0.1
                                                    20 .. 199.9 to next 10
                                              and so on */
                    if (!chart1.ChartAreas[0].AxisX.IsLogarithmic)
                    {
                        if (Math.Abs(maxX) > Math.Abs(minX)) maxabswert = Math.Abs(maxX);
                        else maxabswert = Math.Abs(minX);
                        if (maxabswert <= 2) add = -1; else add = 0;
                        zehnerpot = (int)(Math.Log(maxabswert / 2) / Math.Log(10) + add);
                        xGap = Math.Round(Math.Exp(Math.Log(10) * (zehnerpot)), 10);
                        if (maxX > 0) add = 1; else add = 0;
                        xMax = xGap * (int)(maxX / xGap + add);
                        if (minX >= 0) add = 0; else add = -1;
                        xMin = xGap * (int)(minX / xGap + add);

                        chart1.ChartAreas[0].AxisX.Minimum = xMin;
                        if (xMin == xMax)
                            chart1.ChartAreas[0].AxisX.Maximum = xMin + 0.1; // Case if horizontal curve
                        else
                            chart1.ChartAreas[0].AxisX.Maximum = xMax;
                        chart1.ChartAreas[0].AxisX.Interval = xGap;
                        chart1.ChartAreas[0].AxisX.MinorGrid.Interval = xGap / 5.0;
                        frmscaling.XGaptextBox.Text = chart1.ChartAreas[0].AxisX.Interval.ToString();
                        frmscaling.XminGaptextBox.Text = chart1.ChartAreas[0].AxisX.MinorGrid.Interval.ToString();
                        frmscaling.tBCursorX.Text = chart1.ChartAreas[0].CursorX.Interval.ToString();
                        frmscaling.XMaxtextBox.Text = chart1.ChartAreas[0].AxisX.Maximum.ToString();
                        frmscaling.XMintextBox.Text = chart1.ChartAreas[0].AxisX.Minimum.ToString();

                   }
                    
                    chart1.ChartAreas[0].AxisY2.Minimum = y2Min;
                    if (y2Min == y2Max)
                        chart1.ChartAreas[0].AxisY2.Maximum = y2Min + 0.1;// Case if horizontal curve
                    else
                        chart1.ChartAreas[0].AxisY2.Maximum = y2Max;
                    chart1.ChartAreas[0].AxisY2.Interval = yGap*2;  // ab 7.15 doppelt so groß, war zu fein
                    chart1.ChartAreas[0].AxisY2.MinorGrid.Interval = yGap*2 / 5.0;
                    //chart1.ChartAreas[0].CursorX.Interval = xGap / 10.0;
                    //chart1.ChartAreas[0].CursorY.Interval = yGap / 10.0;
                    // nix for Y2
                    frmscaling.Y2GaptextBox.Text = chart1.ChartAreas[0].AxisY2.Interval.ToString();
                    frmscaling.Y2MinGaptextBox.Text = chart1.ChartAreas[0].AxisY2.MinorGrid.Interval.ToString();
                    frmscaling.Y2MaxtextBox.Text = chart1.ChartAreas[0].AxisY2.Maximum.ToString();
                    frmscaling.Y2MintextBox.Text = chart1.ChartAreas[0].AxisY2.Minimum.ToString();

                    chart1.Invalidate();
                }
            }
        }

        public void Fix_YwithY2()
        {
            if (chart1.ChartAreas[0].AxisY2.Enabled==System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True)
            {
                double deltaY = yMax - yMin;
                double deltaY2 = y2Max - y2Min;
                double neuY2Min = 0;
                long fak = 1;
                if (deltaY2!=0)
                {
                    fak=(long)Math.Truncate(deltaY2 / deltaY) + 1;
                    if (fak > 10) fak = 10;
                    if (fak < 0) fak = 1;
                    neuY2Min = y2Max - (fak) * deltaY; //Ganzzahlig Vielfaches des Y- Range
                    chart1.ChartAreas[0].AxisY2.Minimum = neuY2Min;
                }
                chart1.ChartAreas[0].AxisY2.Interval = chart1.ChartAreas[0].AxisY.Interval*fak;
                chart1.ChartAreas[0].AxisY2.MinorGrid.Interval = chart1.ChartAreas[0].AxisY.MinorGrid.Interval*fak;
                frmscaling.Y2GaptextBox.Text = chart1.ChartAreas[0].AxisY2.Interval.ToString();
                frmscaling.Y2MinGaptextBox.Text = chart1.ChartAreas[0].AxisY2.MinorGrid.Interval.ToString();
                frmscaling.Y2MaxtextBox.Text = chart1.ChartAreas[0].AxisY2.Maximum.ToString();
                frmscaling.Y2MintextBox.Text = chart1.ChartAreas[0].AxisY2.Minimum.ToString();


            }
        }
        #endregion



        #endregion

        #endregion

        #region Hintergrundfarbe

        private void buttonBackColor_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true; //Gesamtes Farbfenster öffnen

            if (chart1.ChartAreas.Count > 0)
            {
                colorDialog1.FullOpen = true;
                colorDialog1.Color = chart1.ChartAreas[0].BackColor;

                if (colorDialog1.ShowDialog() == DialogResult.OK)
                {
                    chart1.ChartAreas[0].BackColor = colorDialog1.Color;
                    chart1.BackColor = colorDialog1.Color;
                }
            }
        }

        #endregion

        #region Farbe Schwarz Wechsel

        private void checkButtonColorBlack_Click(object sender, EventArgs e)
        {
            frmColChange.Show();
        }

        #endregion

        #region Zeichenstärke

        //Ändert die Pixelstärke der einzelnen Pens der 10 Kurven
        private void checkButtonPenScale_Click(object sender, EventArgs e)
        {
            if (chart1.Series.Count > 0)
            {
                if (PenScale == 1)
                {
                    PenScale = 3;

                }
                else
                {
                    PenScale = 1;
                }
                foreach (Series s in chart1.Series)
                    s.BorderWidth = (int)PenScale;
            }
        }

        #endregion

        #region Letzte Kurve löschen

        //Ruft die Funktion zum Löschen der letzten Kurve auf
        private void buttonLastClear_Click(object sender, EventArgs e)
        {
            clearLast();
            OnCounterChange(new CounterChangedEventArgs(chart1.Series.Count));
        }

        #endregion

        #region Alle Kurven löschen

        //Ruft die Funktion zum Löschen aller Kurven auf
        private void buttonAllClear_Click(object sender, EventArgs e)
        {
            clearAll();
            OnCounterChange(new CounterChangedEventArgs(chart1.Series.Count));
        }

        #endregion

        #region Infofenster

        private void buttonInfo_Click(object sender, EventArgs e)
        {
            AboutBox1 info = new AboutBox1(); //Neues Objekt erstellen
            info.ShowDialog();  //Infofenster anzeigen
        }

        #endregion

            

 
        private void butLinLog_Click(object sender, EventArgs e)
        {
            if (chart1.ChartAreas[0].AxisX.IsLogarithmic)
            {
               chart1.ChartAreas[0].AxisX.IsLogarithmic = false;
               XLOG = false;
               xlogdesired = false;
               autoScaling();
            }
            else
            {
                XLOG = true;
                xlogdesired = true;
                autoScaling();  //trial of a log- Scaling
                if (chart1.ChartAreas[0].AxisX.Minimum > 0)
                {
                    chart1.ChartAreas[0].AxisX.IsLogarithmic = true;
                }
                else
                {
                    MessageBox.Show(loggehtnicht, loggehtnicht, MessageBoxButtons.OK);
                    XLOG = false;
                    xlogdesired = false;
                    autoScaling();

                }
             }

        }



        #region Legende

        #region Farben der Graphen

        private void InitColor()
        {
            //Farbe der Stifte an die Hintergrundfarbe der Legendenpanels übergeben
            ColorCurve0.BackColor = ColorPen0;
            ColorCurve1.BackColor = ColorPen1;
            ColorCurve2.BackColor = ColorPen2;
            ColorCurve3.BackColor = ColorPen3;
            ColorCurve4.BackColor = ColorPen4;
            ColorCurve5.BackColor = ColorPen5;
            ColorCurve6.BackColor = ColorPen6;
            ColorCurve7.BackColor = ColorPen7;
            ColorCurve8.BackColor = ColorPen8;
            ColorCurve9.BackColor = ColorPen9;
            ColorBeforBW[0] = ColorPen0;
            ColorBeforBW[1] = ColorPen1;
            ColorBeforBW[2] = ColorPen2;
            ColorBeforBW[3] = ColorPen3;
            ColorBeforBW[4] = ColorPen4;
            ColorBeforBW[5] = ColorPen5;
            ColorBeforBW[6] = ColorPen6;
            ColorBeforBW[7] = ColorPen7;
            ColorBeforBW[8] = ColorPen8;
            ColorBeforBW[9] = ColorPen9;

        }

        //Beim Anklicken des Legendenpanels kann Farbe der Kurve geändert werden
        private void ColorCurve0_Click(object sender, EventArgs e)
        {
            //Kompletten Farbdialog öffnen (Windows Standard-Farbdialog)
            colorDialog1.FullOpen = true;
            //Farbe der Kurve im Farbfenster anzeigen
            colorDialog1.Color = ColorPen0;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                //Neue Kurvenfarbe zuweisen und PictureBox neu zeichnen
                ColorCurve0.BackColor = colorDialog1.Color;
                ColorPen0 = colorDialog1.Color;
                cutCurve0.ForeColor = colorDialog1.Color;
                chart1.Series[0].Color = colorDialog1.Color;
                ///raphPBox.Invalidate();
            }
        }

        private void ColorCurve1_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen1;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve1.BackColor = colorDialog1.Color;
                ColorPen1 = colorDialog1.Color;
                cutCurve1.ForeColor = colorDialog1.Color;
                chart1.Series[1].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve2_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen2;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve2.BackColor = colorDialog1.Color;
                ColorPen2 = colorDialog1.Color;
                cutCurve2.ForeColor = colorDialog1.Color;
                chart1.Series[2].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve3_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen3;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve3.BackColor = colorDialog1.Color;
                ColorPen3 = colorDialog1.Color;
                cutCurve3.ForeColor = colorDialog1.Color;
                chart1.Series[3].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve4_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen4;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve4.BackColor = colorDialog1.Color;
                ColorPen4 = colorDialog1.Color;
                cutCurve4.ForeColor = colorDialog1.Color;
                chart1.Series[4].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve5_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen5;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve5.BackColor = colorDialog1.Color;
                ColorPen5 = colorDialog1.Color;
                cutCurve5.ForeColor = colorDialog1.Color;
                chart1.Series[5].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve6_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen6;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve6.BackColor = colorDialog1.Color;
                ColorPen6 = colorDialog1.Color;
                cutCurve6.ForeColor = colorDialog1.Color;
                chart1.Series[6].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve7_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen7;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve7.BackColor = colorDialog1.Color;
                ColorPen7 = colorDialog1.Color;
                cutCurve7.ForeColor = colorDialog1.Color;
                chart1.Series[7].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve8_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen8;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve8.BackColor = colorDialog1.Color;
                ColorPen8 = colorDialog1.Color;
                cutCurve8.ForeColor = colorDialog1.Color;
                chart1.Series[8].Color = colorDialog1.Color;
            }
        }

        private void ColorCurve9_Click(object sender, EventArgs e)
        {
            colorDialog1.FullOpen = true;

            colorDialog1.Color = ColorPen9;

            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                ColorCurve9.BackColor = colorDialog1.Color;
                ColorPen9 = colorDialog1.Color;
                cutCurve9.ForeColor = colorDialog1.Color;
                chart1.Series[9].Color = colorDialog1.Color;
            }
        }

        #endregion

        #region Namen der Graphen

        //Wird aufgerufen, wenn in der Legende auf den Kurvennamen geklickt wird
        private void NameCurve0_Click(object sender, EventArgs e)
        {
            //Alten Kurvennamen an das Zusatzfenster übergeben
            frmname.Text = ChangeName + CurveNames[0] + ChangeName2; //<-----------warum hier und nicht bei den anderen Fenstern mir drin? 
            frmname.NameTextBox.Text = CurveNames[0];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                //Neuen Namen übergeben
                CurveNames[0] = frmname.NameTextBox.Text;
                cutCurve0.Text = frmname.NameTextBox.Text;
                NameCurve0.Text = frmname.NameTextBox.Text;
                //Name an die DataGridView Spalte übergeben
                dataGridView1.Columns[0].Name = CurveNames[0] + ": X";
                dataGridView1.Columns[1].Name = CurveNames[0] + ": Y";
                chart1.Series[0].LegendText= frmname.NameTextBox.Text;
            }
        }

        private void NameCurve1_Click(object sender, EventArgs e)
        {

            frmname.Text = ChangeName + CurveNames[1] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[1];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[1] = frmname.NameTextBox.Text;
                cutCurve1.Text = frmname.NameTextBox.Text;
                NameCurve1.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[2].Name = CurveNames[1] + ": X";
                dataGridView1.Columns[3].Name = CurveNames[1] + ": Y";
                chart1.Series[1].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve2_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[2] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[2];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[2] = frmname.NameTextBox.Text;
                cutCurve2.Text = frmname.NameTextBox.Text;
                NameCurve2.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[4].Name = CurveNames[2] + ": X";
                dataGridView1.Columns[5].Name = CurveNames[2] + ": Y";
                chart1.Series[2].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve3_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[3] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[3];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[3] = frmname.NameTextBox.Text;
                cutCurve3.Text = frmname.NameTextBox.Text;
                NameCurve3.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[6].Name = CurveNames[3] + ": X";
                dataGridView1.Columns[7].Name = CurveNames[3] + ": Y";
                chart1.Series[3].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve4_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[4] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[4];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[4] = frmname.NameTextBox.Text;
                cutCurve4.Text = frmname.NameTextBox.Text;
                NameCurve4.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[8].Name = CurveNames[4] + ": X";
                dataGridView1.Columns[9].Name = CurveNames[4] + ": Y";
                chart1.Series[4].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve5_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[5] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[5];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[5] = frmname.NameTextBox.Text;
                cutCurve5.Text = frmname.NameTextBox.Text;
                NameCurve5.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[10].Name = CurveNames[5] + ": X";
                dataGridView1.Columns[11].Name = CurveNames[5] + ": Y";
                chart1.Series[5].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve6_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[6] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[6];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[6] = frmname.NameTextBox.Text;
                cutCurve6.Text = frmname.NameTextBox.Text;
                NameCurve6.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[12].Name = CurveNames[6] + ": X";
                dataGridView1.Columns[13].Name = CurveNames[6] + ": Y";
                chart1.Series[6].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve7_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[7] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[7];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[7] = frmname.NameTextBox.Text;
                cutCurve7.Text = frmname.NameTextBox.Text;
                NameCurve7.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[14].Name = CurveNames[7] + ": X";
                dataGridView1.Columns[15].Name = CurveNames[7] + ": Y";
                chart1.Series[7].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve8_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[8] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[8];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[8] = frmname.NameTextBox.Text;
                cutCurve8.Text = frmname.NameTextBox.Text;
                NameCurve8.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[16].Name = CurveNames[8] + ": X";
                dataGridView1.Columns[17].Name = CurveNames[8] + ": Y";
                chart1.Series[8].LegendText = frmname.NameTextBox.Text;
            }
        }

        private void NameCurve9_Click(object sender, EventArgs e)
        {
            frmname.Text = ChangeName + CurveNames[9] + ChangeName2;
            frmname.NameTextBox.Text = CurveNames[9];

            if (frmname.ShowDialog() == DialogResult.OK)
            {
                CurveNames[9] = frmname.NameTextBox.Text;
                cutCurve9.Text = frmname.NameTextBox.Text;
                NameCurve9.Text = frmname.NameTextBox.Text;

                dataGridView1.Columns[18].Name = CurveNames[9] + ": X";
                dataGridView1.Columns[19].Name = CurveNames[9] + ": Y";
                chart1.Series[9].LegendText = frmname.NameTextBox.Text;
            }
        }

        #endregion

        #endregion

        #region Kontextmenü Zeige Koordinaten Abschneiden Mausbewegung


 
        private void chart1_MouseMove(object sender, MouseEventArgs e)
        {
            MousePos = new Point(e.X, e.Y);
            chart1.Invalidate();

            if ((showKoord.Checked) || (cutClick))
                ShowCoorValues(e);
        }



        private void ShowCoorValues(MouseEventArgs e)
        {

            HitTestResult results = chart1.HitTest(e.X, e.Y, ChartElementType.PlottingArea);
            if (results.ChartElementType == ChartElementType.PlottingArea)
            {
                //ChartAreaName = results.ChartArea.Name;

                label1.Visible = true;
                label1.Left = MousePos.X - 90;
                label1.Top = MousePos.Y - 30;
                string help;
                xVal = results.ChartArea.AxisX.PixelPositionToValue(e.X);
                chart1.ChartAreas[0].CursorX.Position = xVal;
                if (chart1.ChartAreas[0].AxisX.IsLogarithmic) xVal = Math.Pow(10, xVal);
                yVal = results.ChartArea.AxisY.PixelPositionToValue(e.Y);
                chart1.ChartAreas[0].CursorY.Position = yVal;
                help = "X = " + String.Format("{0:g3}", xVal) + " Y = " + String.Format("{0:g3}", yVal);
                if (chart1.ChartAreas[0].AxisY2.Enabled == System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True)
                {
                    y2Val = results.ChartArea.AxisY2.PixelPositionToValue(e.Y);
                    help += " y2="+y2Val.ToString("g3");
                }
                label1.Text = help;

            }
        }



        private void contextMenuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            if (e.ClickedItem.Name == "showKoord" && !showKoord.Checked ) //Auswahl Mauskreuz festlegen
            {
                //Haken wird gesetzt und Koordinatenanzeige wird ausgewählt
                //Haken setzen und Status auf "gesetzt" stellen
                //showKoord.Checked = true;
                showKoord.CheckState = CheckState.Checked;
                chart1.ChartAreas[0].CursorX.IsUserEnabled = true;
                chart1.ChartAreas[0].CursorY.IsUserEnabled = true;
                chart1.ChartAreas[0].CursorY.LineColor = Color.Red;
                chart1.ChartAreas[0].CursorX.LineColor = Color.Red;

            }
            else if (e.ClickedItem.Name == "showKoord" && showKoord.Checked) //Auswahl Mauskreuz aufheben
            {
                //Haken entfernen und Status auf "nicht gesetzt" stellen
                //showKoord.Checked = false;
                showKoord.CheckState = CheckState.Unchecked;
                //neu zeichnen, damit Mauskreuz zum Anzeigen der Koordinaten nach Deaktivierung verschwindet
                chart1.Invalidate();
                toolTip1.RemoveAll(); //Koordinatenanzeige deaktivieren, da Koordinaten teilweise noch angezeigt wurden
                chart1.ChartAreas[0].CursorX.IsUserEnabled = false;
                chart1.ChartAreas[0].CursorX.IsUserSelectionEnabled = false;
                chart1.ChartAreas[0].CursorY.IsUserEnabled = false;
                chart1.ChartAreas[0].CursorY.IsUserSelectionEnabled = false;
                label1.Visible = false;
                chart1.ChartAreas[0].CursorX.Position = chart1.ChartAreas[0].AxisX.Minimum;  //Mache Cursorlinien unsichtbar: auf Achse legen
                chart1.ChartAreas[0].CursorY.Position = chart1.ChartAreas[0].AxisY.Minimum;
                chart1.ChartAreas[0].CursorY.LineColor = Color.Black;
                chart1.ChartAreas[0].CursorX.LineColor = Color.Black;

            }
        }

        #endregion

        #region Untermenü von Abschneiden

        //Auswahl der abzuschneidenden Kurve

        private void cutCurveGeneral()
        {
            cutClick = true; //wird im Paint-Ereignis abgefragt, ob Abschneidelinie gezeichnet werden soll
           //Falls Koordinatenanzeige aktiviert ist, wird diese ausgeschaltet
            if (showKoord.Checked )
            {
                //showKoord.Checked = false;
                showKoord.CheckState = CheckState.Unchecked;
            }
            chart1.ChartAreas[0].CursorY.LineColor = Color.Red;
            chart1.ChartAreas[0].CursorX.LineColor = Color.Red;

        }
        
        private void cutCurve0_Click(object sender, EventArgs e)
        {
            cutSelect = 0; //wird im MouseClick-Ereignis der chart1 abgefragt, welche Kurve abgeschnitten werden soll
            cutCurveGeneral();
         }

        private void cutCurve1_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 1;
        }

        private void cutCurve2_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 2;
        }

        private void cutCurve3_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 3;
        }

        private void cutCurve4_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 4;
        }

        private void cutCurve5_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 5;
        }

        private void cutCurve6_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 6;
        }

        private void cutCurve7_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 7;
        }

        private void cutCurve8_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 8;
        }

        private void cutCurve9_Click(object sender, EventArgs e)
        {
            cutCurveGeneral();
            cutSelect = 9;
        }


        private void chart1_MouseClick(object sender, MouseEventArgs e)
        {
            if ((cutClick) && (e.Button == System.Windows.Forms.MouseButtons.Left))
            {
                CutTheGraph();
                cutClick = false;

                label1.Visible = false;
                chart1.ChartAreas[0].CursorX.IsUserEnabled = false;
                chart1.ChartAreas[0].CursorX.IsUserSelectionEnabled = false;
                chart1.ChartAreas[0].CursorY.IsUserEnabled = false;
                chart1.ChartAreas[0].CursorY.IsUserSelectionEnabled = false;
                chart1.ChartAreas[0].CursorX.Position = chart1.ChartAreas[0].AxisX.Minimum;  //Mache Cursorlinien unsichtbar: auf Achse legen
                chart1.ChartAreas[0].CursorY.Position = chart1.ChartAreas[0].AxisY.Minimum;
                chart1.ChartAreas[0].CursorY.LineColor = Color.Black;
                chart1.ChartAreas[0].CursorX.LineColor = Color.Black;
            }
            if ((showKoord.Checked) && (e.Button == System.Windows.Forms.MouseButtons.Left))
            {
                OnCoordClick(new CoordClickEventArgs(xVal, yVal));
            }

        }

        private void CutTheGraph()
        {
            Series curve = chart1.Series[cutSelect];
            int i = 0;

            if (MessageBox.Show("Cut curve at this position ?", "Confirm", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
            {
                while (i < curve.Points.Count)
                {
                    if (curve.Points[i].XValue > xVal)
                    {
                        curve.Points.RemoveAt(i);
                        i--;
                    }
                    i++;
                }
            }

            chart1.Invalidate();
            CurvePoints[cutSelect] = curve.Points.Count;  // Zum Abschneiden in Windf nötig, geändert 6.11.2014
        }  
        #endregion

 
        #region Drucken

 
        #region Hinzufügen der Legende

        private void DrawLegend(Graphics g)
        {
            //Verschiebung und Rotation des Koordinatenursprungs zurücksetzen (Sonst ist die Schrift spiegelverkehrt)
            g.ResetTransform();

            //Neuen Koordinatenursprung festlegen
            g.TranslateTransform(450 + 100, 100);

            //Zeichenobjekte festlegen (Schriftart, Schriftfarbe, Zentriert)
            Font titleFont = new Font("Arial", 8);
            SolidBrush blackBrush = new SolidBrush(Color.Black);

            SolidBrush curve0Brush = new SolidBrush(ColorPen0);
            SolidBrush curve1Brush = new SolidBrush(ColorPen1);
            SolidBrush curve2Brush = new SolidBrush(ColorPen2);
            SolidBrush curve3Brush = new SolidBrush(ColorPen3);
            SolidBrush curve4Brush = new SolidBrush(ColorPen4);
            SolidBrush curve5Brush = new SolidBrush(ColorPen5);
            SolidBrush curve6Brush = new SolidBrush(ColorPen6);
            SolidBrush curve7Brush = new SolidBrush(ColorPen7);
            SolidBrush curve8Brush = new SolidBrush(ColorPen8);
            SolidBrush curve9Brush = new SolidBrush(ColorPen9);


            g.DrawString(labelLegend.Text, titleFont, blackBrush, 10, 10); //Überschrift (Legende) zeichnen

            //Kurvennamen zeichnen
            if (chart1.Series[0].Points.Count > 0)
            {
                g.FillRectangle(curve0Brush, 0f, 40f, 10f, 10f);
                g.DrawString(CurveNames[0], titleFont, blackBrush, 20f, 41f);
            }
            if (chart1.Series[1].Points.Count > 0)
            {
                g.FillRectangle(curve1Brush, 0f, 60f, 10f, 10f);
                g.DrawString(CurveNames[1], titleFont, blackBrush, 20f, 61f);
            }
            if (chart1.Series[2].Points.Count > 0)
            {
                g.FillRectangle(curve2Brush, 0f, 80f, 10f, 10f);
                g.DrawString(CurveNames[2], titleFont, blackBrush, 20f, 81f);
            }
            if (chart1.Series[3].Points.Count > 0)
            {
                g.FillRectangle(curve3Brush, 0f, 100f, 10f, 10f);
                g.DrawString(CurveNames[3], titleFont, blackBrush, 20f, 101f);
            }
            if (chart1.Series[4].Points.Count > 0)
            {
                g.FillRectangle(curve4Brush, 0f, 120f, 10f, 10f);
                g.DrawString(CurveNames[4], titleFont, blackBrush, 20f, 121f);
            }
            if (chart1.Series[5].Points.Count > 0)
            {
                g.FillRectangle(curve5Brush, 0f, 140f, 10f, 10f);
                g.DrawString(CurveNames[5], titleFont, blackBrush, 20f, 141f);
            }
            if (chart1.Series[6].Points.Count > 0)
            {
                g.FillRectangle(curve6Brush, 0f, 160f, 10f, 10f);
                g.DrawString(CurveNames[6], titleFont, blackBrush, 20f, 161f);
            }
            if (chart1.Series[7].Points.Count > 0)
            {
                g.FillRectangle(curve7Brush, 0f, 180f, 10f, 10f);
                g.DrawString(CurveNames[7], titleFont, blackBrush, 20f, 181f);
            }
            if (chart1.Series[8].Points.Count > 0)
            {
                g.FillRectangle(curve8Brush, 0f, 200f, 10f, 10f);
                g.DrawString(CurveNames[8], titleFont, blackBrush, 20f, 201f);
            }
            if (chart1.Series[9].Points.Count > 0)
            {
                g.FillRectangle(curve9Brush, 0f, 220f, 10f, 10f);
                g.DrawString(CurveNames[9], titleFont, blackBrush, 20f, 221f);
            }                   

            //Zeichenressourcen freigeben
            titleFont.Dispose();
            blackBrush.Dispose();
            curve0Brush.Dispose();
            curve1Brush.Dispose();
            curve2Brush.Dispose();
            curve3Brush.Dispose();
            curve4Brush.Dispose();
            curve5Brush.Dispose();
            curve6Brush.Dispose();
            curve7Brush.Dispose();
            curve8Brush.Dispose();
            curve9Brush.Dispose();

        }

        #endregion

        #region Rahmen

        //Verhindert das Drucken aus dem Koordinatenkreuz, wenn die Kurve die Min und Max Werte überschreitet
        private void DrawWhiteBackground(Graphics g, bool landscape)
        {
            SolidBrush white = new SolidBrush(Color.White);
            Rectangle rectleft;
            Rectangle rectright;
            Rectangle recttop;
            Rectangle rectbottom;

            //Querformat
            if (landscape == true)
            {
                //Abmessung der Rechtecke (Weißer Rahmen um die Zeichenfläche)
                rectleft = new Rectangle(-100, -100, 98, 500);
                rectright = new Rectangle(450, -100, 200, 500);
                recttop = new Rectangle(-5, 276, 460, 200);
                rectbottom = new Rectangle(-5, -100, 460, 99);
            }
            else //Hochformat
            {
                //Abmessung der Rechtecke (Weißer Rahmen um die Zeichenfläche)
                rectleft = new Rectangle(-100, -100, 98, 500);
                rectright = new Rectangle(450, -100, 200, 500);
                recttop = new Rectangle(-5, 276, 460, 200);
                rectbottom = new Rectangle(-100, -610, 760, 609);
            }

            //Rechtecke zeichnen (Rahmen)
            g.FillRectangle(white, rectleft);
            g.FillRectangle(white, rectright);
            g.FillRectangle(white, recttop);
            g.FillRectangle(white, rectbottom);

            //Zeichenressource freigeben
            white.Dispose();
        }

        #endregion

        #endregion

        #region Speichern und Laden einer Datei

        #region Erstellen einer Speicherdatei

        private void saveChart(string filePath)
        {
            // Von Dao:
            chart1.Serializer.Content = SerializationContents.Default;
            chart1.Serializer.Save(filePath);

            ////Neues StreamWriter-Objekt erstellen
            //StreamWriter sw = new StreamWriter(filePath);
            
            //if (sw != null)
            //{
            //    //Anzahl der Kurven in Datei schreiben
            //    sw.WriteLine(curveCount); 

            //    //Über- und Unterschritf in Datei schreiben
            //    sw.WriteLine(topTitle); 
            //    sw.WriteLine(bottomTitle);

            //    //Min, Max und Gap Werte in Datei schreiben
            //    sw.WriteLine(xMax);
            //    sw.WriteLine(xMin);
            //    sw.WriteLine(xGap);
            //    sw.WriteLine(yMax);
            //    sw.WriteLine(yMin);
            //    sw.WriteLine(yGap);

            //    //Hintergrundfarbe in Datei schreiben (Einzelne RGB-Werte)
            //    sw.WriteLine(GraphPBox.BackColor.R + ";" + GraphPBox.BackColor.G + ";" + GraphPBox.BackColor.B);

            //    //Wenn Kurve vorhanden
            //    if (Curve0X.Count > 0)
            //    {
            //        //Kurvenname in Datei schreiben
            //        sw.WriteLine(CurveNames[0]);
            //        //Kurvenfarbe in Datei schreiben (Einzelne RGB-Werte)
            //        sw.WriteLine(ColorPen0.R + ";" + ColorPen0.G + ";" + ColorPen0.B);
            //        //Anzahl der Punkte in Datei schreiben
            //        sw.WriteLine(Curve0X.Count);
            //        for (int i = 0; i < Curve0X.Count; i++)
            //        {
            //            //X und Y Wert nacheinader in Datei schreiben
            //            sw.WriteLine(Curve0X[i]);
            //            sw.WriteLine(Curve0Y[i]);
            //        }
            //    }

            //    if (Curve1X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[1]);
            //        sw.WriteLine(ColorPen1.R + ";" + ColorPen1.G + ";" + ColorPen1.B);
            //        sw.WriteLine(Curve1X.Count);
            //        for (int i = 0; i < Curve1X.Count; i++)
            //        {
            //            sw.WriteLine(Curve1X[i]);
            //            sw.WriteLine(Curve1Y[i]);
            //        }
            //    }
            //    if (Curve2X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[2]);
            //        sw.WriteLine(ColorPen2.R + ";" + ColorPen2.G + ";" + ColorPen2.B);
            //        sw.WriteLine(Curve2X.Count);
            //        for (int i = 0; i < Curve2X.Count; i++)
            //        {
            //            sw.WriteLine(Curve2X[i]);
            //            sw.WriteLine(Curve2Y[i]);
            //        }
            //    }

            //    if (Curve3X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[3]);
            //        sw.WriteLine(ColorPen3.R + ";" + ColorPen3.G + ";" + ColorPen3.B);
            //        sw.WriteLine(Curve3X.Count);
            //        for (int i = 0; i < Curve3X.Count; i++)
            //        {
            //            sw.WriteLine(Curve3X[i]);
            //            sw.WriteLine(Curve3Y[i]);
            //        }
            //    }

            //    if (Curve4X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[4]);
            //        sw.WriteLine(ColorPen4.R + ";" + ColorPen4.G + ";" + ColorPen4.B);
            //        sw.WriteLine(Curve4X.Count);
            //        for (int i = 0; i < Curve4X.Count; i++)
            //        {
            //            sw.WriteLine(Curve4X[i]);
            //            sw.WriteLine(Curve4Y[i]);
            //        }
            //    }

            //    if (Curve5X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[5]);
            //        sw.WriteLine(ColorPen5.R + ";" + ColorPen5.G + ";" + ColorPen5.B);
            //        sw.WriteLine(Curve5X.Count);
            //        for (int i = 0; i < Curve5X.Count; i++)
            //        {
            //            sw.WriteLine(Curve5X[i]);
            //            sw.WriteLine(Curve5Y[i]);
            //        }
            //    }

            //    if (Curve6X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[6]);
            //        sw.WriteLine(ColorPen6.R + ";" + ColorPen6.G + ";" + ColorPen6.B);
            //        sw.WriteLine(Curve6X.Count);
            //        for (int i = 0; i < Curve6X.Count; i++)
            //        {
            //            sw.WriteLine(Curve6X[i]);
            //            sw.WriteLine(Curve6Y[i]);
            //        }
            //    }

            //    if (Curve7X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[7]);
            //        sw.WriteLine(ColorPen7.R + ";" + ColorPen7.G + ";" + ColorPen7.B);
            //        sw.WriteLine(Curve7X.Count);
            //        for (int i = 0; i < Curve7X.Count; i++)
            //        {
            //            sw.WriteLine(Curve7X[i]);
            //            sw.WriteLine(Curve7Y[i]);
            //        }
            //    }

            //    if (Curve8X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[8]);
            //        sw.WriteLine(ColorPen8.R + ";" + ColorPen8.G + ";" + ColorPen8.B);
            //        sw.WriteLine(Curve8X.Count);
            //        for (int i = 0; i < Curve8X.Count; i++)
            //        {
            //            sw.WriteLine(Curve8X[i]);
            //            sw.WriteLine(Curve8Y[i]);
            //        }
            //    }

            //    if (Curve9X.Count > 0)
            //    {
            //        sw.WriteLine(CurveNames[9]);
            //        sw.WriteLine(ColorPen9.R + ";" + ColorPen9.G + ";" + ColorPen9.B);
            //        sw.WriteLine(Curve9X.Count);
            //        for (int i = 0; i < Curve9X.Count; i++)
            //        {
            //            sw.WriteLine(Curve9X[i]);
            //            sw.WriteLine(Curve9Y[i]);
            //        }
            //    }
            //    //Datei schließen
            //    sw.Close();
            //}
        }

        #endregion

        #region Laden einer Speicherdatei

        private void loadChart(string filePath)
        {
            // von Dao:
            chart1.Serializer.Load(filePath);
            //Counter = chart1.Series.Count; // geht automatisch bei Abfrage
            for (int i=0;i<chart1.Series.Count;i++) // Ab 7.12 aktualisieren der Kurvenpunkte
            {
                pointsCount[i] = chart1.Series[i].Points.Count;
                CurvePoints[i] = chart1.Series[i].Points.Count;
                CurveNames[i] = chart1.Series[i].LegendText;   // Neu seit 7.23 Laden auch der Legende
            }

            ////Anzahl der Punkte in der Kurve
            //int count = 0;

            ////String mit der Zeile, in der die RGB-Werte stehen 
            //string colorString;
            ////Array für die RGB-Werte der Farben, nachdem sie aus dem String gelesen wurden
            //string[] colorArray = new string[3];
            ////Temporäres Farbobjekt
            //Color tempColor = new Color();

            ////Neues StreamReader-Objekt erstellen
            //StreamReader sr = new StreamReader(filePath);

            //if (sr != null)
            //{
            //    //Anzahl der Kurven aus Datei lesen
            //    curveCount = Convert.ToInt32(sr.ReadLine());

            //    //Über- und Unterschrift aus Datei lesen
            //    topTitle = sr.ReadLine();
            //    bottomTitle = sr.ReadLine();

            //    //Min, Max und Gap Werte aus Datei lesen
            //    xMax = Convert.ToDouble(sr.ReadLine());
            //    xMin = Convert.ToDouble(sr.ReadLine());
            //    xGap = Convert.ToDouble(sr.ReadLine());
            //    yMax = Convert.ToDouble(sr.ReadLine());
            //    yMin = Convert.ToDouble(sr.ReadLine());
            //    yGap = Convert.ToDouble(sr.ReadLine());

            //    //RGB-Werte aus Datei lesen
            //    colorString = sr.ReadLine();
            //    //String aufteilen und in Array speichern
            //    colorArray = colorString.Split(';');
            //    //Einzelne RGB-Werte der temporären Farbe übergeben
            //    tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //    //Hintergrundfarbe übergeben
            //    GraphPBox.BackColor = tempColor;
            //    AxisPBox.BackColor = tempColor;

            //    //Kurvenname aus Datei lesen
            //    CurveNames[0] = sr.ReadLine();
            //    //Wenn Kurvenname vorhanden
            //    if (CurveNames[0] != null)
            //    {
            //        //RGB-Werte aus Datei lesen
            //        colorString = sr.ReadLine();
            //        //String aufteilen und in Array speichern
            //        colorArray = colorString.Split(';');
            //        //Einzelne RGB-Werte der temporären Farbe übergeben
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        //Kurvenfarbe übergeben
            //        ColorPen0 = tempColor;
            //        //Anzahl der Kurvenpunkte aus Datei lesen
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            //X und Y Wert aus Datei lesen
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            //Kurvenpunkte mit setPoint() speichern
            //            setPoint(0, x, y);
            //        }
            //    }

            //    CurveNames[1] = sr.ReadLine();
            //    if (CurveNames[1] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen1 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(1, x, y);
            //        }
            //    }

            //    CurveNames[2] = sr.ReadLine();
            //    if (CurveNames[2] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen2 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(2, x, y);
            //        }
            //    }

            //    CurveNames[3] = sr.ReadLine();
            //    if (CurveNames[3] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen3 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(3, x, y);
            //        }
            //    }

            //    CurveNames[4] = sr.ReadLine();
            //    if (CurveNames[4] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen4 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(4, x, y);
            //        }
            //    }

            //    CurveNames[5] = sr.ReadLine();
            //    if (CurveNames[5] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen5 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(5, x, y);
            //        }
            //    }

            //    CurveNames[6] = sr.ReadLine();
            //    if (CurveNames[6] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen6 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(6, x, y);
            //        }
            //    }

            //    CurveNames[7] = sr.ReadLine();
            //    if (CurveNames[7] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen7 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(7, x, y);
            //        }
            //    }

            //    CurveNames[8] = sr.ReadLine();
            //    if (CurveNames[8] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen8 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(8, x, y);
            //        }
            //    }

            //    CurveNames[9] = sr.ReadLine();
            //    if (CurveNames[9] != null)
            //    {
            //        colorString = sr.ReadLine();
            //        colorArray = colorString.Split(';');
            //        tempColor = Color.FromArgb(Convert.ToByte(colorArray[0]), Convert.ToByte(colorArray[1]), Convert.ToByte(colorArray[2]));
            //        ColorPen9 = tempColor;
            //        count = Convert.ToInt32(sr.ReadLine());
            //        for (int i = 0; i < count; i++)
            //        {
            //            double x = Convert.ToDouble(sr.ReadLine());
            //            double y = Convert.ToDouble(sr.ReadLine());

            //            setPoint(9, x, y);
            //        }
            //    }

            //    //Datei schließen
            //    sr.Close();

            //    //DataGridView aktualisieren
            //    setEData();

            //    //Neu zeichnen
            //    AxisPBox.Invalidate();
            //    GraphPBox.Invalidate();
            //}
        }

        #endregion

        #endregion

        #region Hinzugefügte Eigenschaften

        #region Achseneigenschaften

        [Category("Achseneinstellung")]
        [Description("Minimaler X-Wert")]
        public double XMin
        {
            get { return this.chart1.ChartAreas[0].AxisX.Minimum; }
            set { this.chart1.ChartAreas[0].AxisX.Minimum = value; chart1.Invalidate(); } 
        }

        [Category("Achseneinstellung")]
        [Description("Maximaler X-Wert")]
        public double XMax
        {
            get { return this.chart1.ChartAreas[0].AxisX.Maximum; }
            set { this.chart1.ChartAreas[0].AxisX.Maximum = value; chart1.Invalidate();  }
        }

        [Category("Achseneinstellung")]
        [Description("X-Achseneinteilung")]
        public double XGap
        {
            get { return this.chart1.ChartAreas[0].AxisX.Interval ; }
            set { this.chart1.ChartAreas[0].AxisX.Interval = value; chart1.Invalidate();  }
        }

        [Category("Achseneinstellung")]
        [Description("X-MinGrid")]
        public double XMinGrid
        {
            get { return this.chart1.ChartAreas[0].AxisX.MinorGrid.Interval; }
            set { this.chart1.ChartAreas[0].AxisX.MinorGrid.Interval = value; chart1.Invalidate(); }
        }
        [Category("Achseneinstellung")]
        [Description("X-MajGrid")]
        public double XMajGrid
        {
            get { return this.chart1.ChartAreas[0].AxisX.MajorGrid.Interval; }
            set { this.chart1.ChartAreas[0].AxisX.MajorGrid.Interval = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("Minimaler Y-Wert")]
        public double YMin
        {
            get { return this.chart1.ChartAreas[0].AxisY.Minimum; }
            set { this.chart1.ChartAreas[0].AxisY.Minimum = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("Maximaler Y-Wert")]
        public double YMax
        {
            get { return this.chart1.ChartAreas[0].AxisY.Maximum; }
            set { this.chart1.ChartAreas[0].AxisY.Maximum = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("Y-Achseneinteilung")]
        public double YGap
        {
            get { return this.chart1.ChartAreas[0].AxisY.Interval; }
            set { this.chart1.ChartAreas[0].AxisY.Interval = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("Y-MinGrid")]
        public double YMinGrid
        {
            get { return this.chart1.ChartAreas[0].AxisY.MinorGrid.Interval; }
            set { this.chart1.ChartAreas[0].AxisY.MinorGrid.Interval = value; chart1.Invalidate(); }
        }
        [Category("Achseneinstellung")]
        [Description("Y-MajGrid")]
        public double YMajGrid
        {
            get { return this.chart1.ChartAreas[0].AxisY.MajorGrid.Interval; }
            set { this.chart1.ChartAreas[0].AxisY.MajorGrid.Interval = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("X-Grid")]
        public bool XGrid
        {
            get { return this.chart1.ChartAreas[0].AxisX.MajorGrid.Enabled; }
            set { this.chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("Y-Grid")]
        public bool YGrid
        {
            get { return this.chart1.ChartAreas[0].AxisY.MajorGrid.Enabled; }
            set { this.chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("X-Grid")]
        public bool Y2Grid
        {
            get { return this.chart1.ChartAreas[0].AxisY2.MajorGrid.Enabled; }
            set { this.chart1.ChartAreas[0].AxisY2.MajorGrid.Enabled = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("X-LOG")]
        public bool XLOG
        {
            get { return this.xlogdesired; }///chart1.ChartAreas[0].AxisX.IsLogarithmic; }
            set   // if true autoscaling tries a log scale
            {
                //if (XLOG)
                //    if (this.chart1.ChartAreas[0].AxisX.Minimum > 0)
                //    {
                //        this.chart1.ChartAreas[0].AxisX.IsLogarithmic = value; chart1.Invalidate();
                //    }
                //    else
                //        MessageBox.Show(loggehtnicht, loggehtnicht, MessageBoxButtons.OK);
                xlogdesired = value;
            }
        }

        [Category("Achseneinstellung")]
        [Description("Y2- Achse aktivieren")]
        public AxisEnabled Y2Enabled
        {
            get { return this.chart1.ChartAreas[0].AxisY2.Enabled; }
            set { this.chart1.ChartAreas[0].AxisY2.Enabled = value; chart1.Invalidate(); }
        }

        [Category("Achseneinstellung")]
        [Description("Y2- Zuordnung der Serien")]
        public bool [] IsY2 
        {
            get { return this.IsY2local; }
            set { this.IsY2local = value;
            for (int i = 0; i < chart1.Series.Count; i++)
            {
                if (IsY2local[i])
                {
                    chart1.ChartAreas[0].AxisY2.Enabled = System.Windows.Forms.DataVisualization.Charting.AxisEnabled.True;
                    chart1.Series[i].YAxisType = System.Windows.Forms.DataVisualization.Charting.AxisType.Secondary;
                }
            }
                chart1.Invalidate();
            }
        }
      
                      

        #endregion

 
        #region Buttons

        [Category("Buttonleiste")]
        [Description("X-Grid Button einblenden/ausblenden")]
        public bool XGridButton
        {
            get { return this.checkButtonXGrid.Visible; }
            set { this.checkButtonXGrid.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Y-Grid Button einblenden/ausblenden")]
        public bool YGridButton
        {
            get { return this.checkButtonYGrid.Visible; }
            set { this.checkButtonYGrid.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Manuelle Skalierung Button einblenden/ausblenden")]
        public bool ScallingButton
        {
            get { return this.buttonScaling.Visible; }
            set { this.buttonScaling.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Automatische Skalierung Button einblenden/ausblenden")]
        public bool AutoScaleButton
        {
            get { return this.buttonAutoScale.Visible; }
            set { this.buttonAutoScale.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Editor Button einblenden/ausblenden")]
        public bool EditorButton
        {
            get { return this.checkButtonEditor.Visible; }
            set { this.checkButtonEditor.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Legende Button einblenden/ausblenden")]
        public bool LegendButton
        {
            get { return this.checkButtonLegend.Visible; }
            set { this.checkButtonLegend.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Alle Kurven löschen Button einblenden/ausblenden")]
        public bool AllClearButton
        {
            get { return this.buttonAllClear.Visible; }
            set { this.buttonAllClear.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Letzte Kurve löschen Button einblenden/ausblenden")]
        public bool LastClearButton
        {
            get { return this.buttonLastClear.Visible; }
            set { this.buttonLastClear.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Schriftstärke Button einblenden/ausblenden")]
        public bool PenScaleButton
        {
            get { return this.checkButtonPenScale.Visible; }
            set { this.checkButtonPenScale.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Hintergrundfarbe Button einblenden/ausblenden")]
        public bool BackColorButton
        {
            get { return this.buttonBackColor.Visible; }
            set { this.buttonBackColor.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Schwarz/Weiß Button einblenden/ausblenden")]
        public bool ColorBlackButton
        {
            get { return this.checkButtonColorBlack.Visible; }
            set { this.checkButtonColorBlack.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Über-/Unterschrift Button einblenden/ausblenden")]
        public bool TitleButton
        {
            get { return this.buttonTitle.Visible; }
            set { this.buttonTitle.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Drucken Button einblenden/ausblenden")]
        public bool PrintButton
        {
            get { return this.buttonPrint.Visible; }
            set { this.buttonPrint.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Zoom Button einblenden/ausblenden")]
        public bool ZoomButton
        {
            get { return this.checkButtonZoom.Visible; }
            set { this.checkButtonZoom.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Info Button einblenden/ausblenden")]
        public bool InfoButton
        {
            get { return this.buttonInfo.Visible; }
            set { this.buttonInfo.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Speicher Button einblenden/ausblenden")]
        public bool SaveButton
        {
            get { return this.buttonSave.Visible; }
            set { this.buttonSave.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("Laden Button einblenden/ausblenden")]
        public bool LoadButton
        {
            get { return this.buttonLoad.Visible; }
            set { this.buttonLoad.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("ButtonLeiste einblenden/ausblenden")]
        public bool ButtonPanel
        {
            get { return this.BPanel.Visible; }
            set { this.BPanel.Visible = value; }
        }

        [Category("Buttonleiste")]
        [Description("LIN- LOG-Button einblenden/ausblenden")]
        public bool ButtonLinLog
        {
            get { return this.butLinLog.Visible; }
            set { this.butLinLog.Visible = value; }
        }

        #endregion

        #region Über-/ Unterschrift

        [Category("Beschriftung")]
        [Description("Bild Überschrift")]
        public string TopTitle
        {
            get
            {
                return this.frmtitle.TopTitletextBox.Text;
            }
            set 
            {
                this.frmtitle.TopTitletextBox.Text = value; 
                init_Titles(); chart1.Invalidate();
            }
        }

        [Category("Beschriftung")]
        [Description("Bild Unterschrift")]
        public string BottomTitle
        {
            get
            {
                return this.frmtitle.BottomTitletextBox.Text;
            }
            set
            {
                this.frmtitle.BottomTitletextBox.Text = value;
                init_Titles(); chart1.Invalidate();
            }
        }

        #endregion


        #region Kurvenfarbe

        [Category("Kurvenfarben")]
        [Description("Kurve 0")]
        public Color CurveColor0
        {
            get { return this.ColorPen0; }
            set
            {
                this.ColorPen0 = value;
                if (chart1.Series.Count > 0)
                    chart1.Series[0].Color = value;
                chart1.Invalidate();
                ColorCurve0.BackColor = ColorPen0;
                cutCurve0.ForeColor = ColorPen0;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 1")]
        public Color CurveColor1
        {
            get { return this.ColorPen1; }
            set
            {
                this.ColorPen1 = value;
                if (chart1.Series.Count > 1)
                    chart1.Series[1].Color = value;
                chart1.Invalidate();
                ColorCurve1.BackColor = ColorPen1;
                cutCurve1.ForeColor = ColorPen1;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 2")]
        public Color CurveColor2
        {
            get { return this.ColorPen2; }
            set
            {
                this.ColorPen2 = value;
                if (chart1.Series.Count > 2)
                    chart1.Series[2].Color = value;
                chart1.Invalidate();
                ColorCurve2.BackColor = ColorPen2;
                cutCurve2.ForeColor = ColorPen2;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 3")]
        public Color CurveColor3
        {
            get { return this.ColorPen3; }
            set
            {
                this.ColorPen3 = value;
                if (chart1.Series.Count > 3)
                    chart1.Series[3].Color = value;
                chart1.Invalidate();
                ColorCurve3.BackColor = ColorPen3;
                cutCurve3.ForeColor = ColorPen3;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 4")]
        public Color CurveColor4
        {
            get { return this.ColorPen4; }
            set
            {
                this.ColorPen4 = value;
                if (chart1.Series.Count > 4)
                    chart1.Series[4].Color = value;
                chart1.Invalidate();
                ColorCurve4.BackColor = ColorPen4;
                cutCurve4.ForeColor = ColorPen4;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 5")]
        public Color CurveColor5
        {
            get { return this.ColorPen5; }
            set
            {
                this.ColorPen5 = value;
                if (chart1.Series.Count > 5)
                    chart1.Series[5].Color = value;
                chart1.Invalidate();
                ColorCurve5.BackColor = ColorPen5;
                cutCurve5.ForeColor = ColorPen5;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 6")]
        public Color CurveColor6
        {
            get { return this.ColorPen6; }
            set
            {
                this.ColorPen6 = value;
                if (chart1.Series.Count > 6)
                    chart1.Series[6].Color = value;
                chart1.Invalidate();
                ColorCurve6.BackColor = ColorPen6;
                cutCurve6.ForeColor = ColorPen6;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 7")]
        public Color CurveColor7
        {
            get { return this.ColorPen7; }
            set
            {
                this.ColorPen7 = value;
                if (chart1.Series.Count > 7)
                    chart1.Series[7].Color = value;
                chart1.Invalidate();
                ColorCurve7.BackColor = ColorPen7;
                cutCurve7.ForeColor = ColorPen7;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 8")]
        public Color CurveColor8
        {
            get { return this.ColorPen8; }
            set
            {
                this.ColorPen8 = value;
                if (chart1.Series.Count > 8)
                    chart1.Series[8].Color = value;
                chart1.Invalidate();
                ColorCurve8.BackColor = ColorPen8;
                cutCurve8.ForeColor = ColorPen8;
            }
        }

        [Category("Kurvenfarben")]
        [Description("Kurve 9")]
        public Color CurveColor9
        {
            get { return this.ColorPen9; }
            set
            {
                this.ColorPen9 = value;
                if (chart1.Series.Count > 9)
                    chart1.Series[9].Color = value;
                chart1.Invalidate();
                ColorCurve9.BackColor = ColorPen9;
                cutCurve9.ForeColor = ColorPen9;
            }
        }

        #endregion


        #region Anzahl der Punkte pro Kurve

        [Category("Kurvenpunkte")]
        [Description("Gibt die Anzahl Punkte pro Kurve an")]
        public int[] CurvePoints
        {
            get { return this.pointsCount; }
            //set { this.pointsCount = value; }
        }

        #endregion

        #region Kurvenzähler

        [Category("Kurvenzähler")]
        [Description("Gibt die Anzahl der vorhandenen Kurven an.\r\n 0: Keine Kurve\r\n 10: Zehn Kurven")]
        public int Counter
        {
            get { return this.chart1.Series.Count; }
            //set { this.curveCount = value; }
        }

        #endregion

        #region Spracheinstellung

        [Category("Spracheinstellung")]
        [Description("Deutsch einschalten")]
        public bool Germanlanguage
        {
            get { return this.ger; }
            set
            {
                this.ger = value;
                if (ger == true) german();
                else english();
            }
        }

        #endregion

        #endregion

        #region Erstellen des Ereignisses CoordClick

        //Zugehöriges Delegate außerhalb der Klasse definiert (siehe oben)

        //Event festlegen (Standardevent des Steuerelements siehe oben)
        public event CoordClickEventHandler CoordClick;

        //Methode zum Auslösen des eigenen Events
        protected virtual void OnCoordClick(CoordClickEventArgs e)
        {
            //Überprüfung auf vorhandene Ereignisbehandlungsroutinen
            if (CoordClick != null) CoordClick(this, e);
        }

   

        public event CounterChangedEventHandler CounterChanged;

        //Methode zum Auslösen des eigenen Events
        protected virtual void OnCounterChange(CounterChangedEventArgs e)
        {
            //Überprüfung auf vorhandene Ereignisbehandlungsroutinen
            if (CounterChanged != null) CounterChanged(this, e);
        }

     #endregion




    }
}